// DO NOT EDIT
// Generated by JFlex 1.9.1 http://jflex.de/
// source: jflex/S182_AliasPartitions.jflex

/*******************************************************************************
 * Copyright (c) 2022-2029 Institute of Legal Information and Judicial Systems (IGSG-CNR)
 * 
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License. 
 * You may obtain a copy of the License at
 * 
 * http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and 
 * limitations under the License.
 *  
 * Authors: Lorenzo Bacci (IGSG-CNR)
 ******************************************************************************/
package it.cnr.igsg.linkoln;

import java.util.ArrayList;


@SuppressWarnings("fallthrough")
class S182_AliasPartitions extends LinkolnAnnotationService {

  /** This character denotes the end of file. */
  public static final int YYEOF = -1;

  /** Initial size of the lookahead buffer. */
  private static final int ZZ_BUFFERSIZE = 16384;

  // Lexical states.
  public static final int YYINITIAL = 0;
  public static final int lkn = 2;
  public static final int globalState = 4;

  /**
   * ZZ_LEXSTATE[l] is the state in the DFA for the lexical state l
   * ZZ_LEXSTATE[l+1] is the state in the DFA for the lexical state l
   *                  at the beginning of a line
   * l is of the form l = 2*k, k a non negative integer
   */
  private static final int ZZ_LEXSTATE[] = {
     0,  0,  1,  1,  2, 2
  };

  /**
   * Top-level table for translating characters to character classes
   */
  private static final int [] ZZ_CMAP_TOP = zzUnpackcmap_top();

  private static final String ZZ_CMAP_TOP_PACKED_0 =
    "\1\0\1\u0100\36\u0200\1\u0300\1\u0400\u10de\u0200";

  private static int [] zzUnpackcmap_top() {
    int [] result = new int[4352];
    int offset = 0;
    offset = zzUnpackcmap_top(ZZ_CMAP_TOP_PACKED_0, offset, result);
    return result;
  }

  private static int zzUnpackcmap_top(String packed, int offset, int [] result) {
    int i = 0;       /* index in packed string  */
    int j = offset;  /* index in unpacked array */
    int l = packed.length();
    while (i < l) {
      int count = packed.charAt(i++);
      int value = packed.charAt(i++);
      do result[j++] = value; while (--count > 0);
    }
    return j;
  }


  /**
   * Second-level tables for translating characters to character classes
   */
  private static final int [] ZZ_CMAP_BLOCKS = zzUnpackcmap_blocks();

  private static final String ZZ_CMAP_BLOCKS_PACKED_0 =
    "\11\0\1\1\1\2\1\0\1\1\1\2\22\0\1\1"+
    "\1\0\1\3\3\0\1\4\1\0\2\5\2\0\2\5"+
    "\1\0\1\6\12\7\1\10\1\11\5\0\1\12\1\13"+
    "\1\14\1\15\1\16\1\17\1\20\1\15\1\21\1\15"+
    "\1\22\1\23\1\24\1\25\1\26\1\27\1\15\1\30"+
    "\1\31\1\32\2\15\1\33\3\15\1\34\1\0\1\35"+
    "\1\0\1\36\1\0\1\37\1\40\1\41\1\0\1\42"+
    "\1\43\1\44\1\0\1\45\1\0\1\46\1\47\1\50"+
    "\1\51\1\52\1\53\1\0\1\54\1\55\1\56\2\0"+
    "\1\57\270\0\2\45\115\0\1\55\u0182\0\1\1\20\0"+
    "\2\5\u0115\0\1\46\325\0";

  private static int [] zzUnpackcmap_blocks() {
    int [] result = new int[1280];
    int offset = 0;
    offset = zzUnpackcmap_blocks(ZZ_CMAP_BLOCKS_PACKED_0, offset, result);
    return result;
  }

  private static int zzUnpackcmap_blocks(String packed, int offset, int [] result) {
    int i = 0;       /* index in packed string  */
    int j = offset;  /* index in unpacked array */
    int l = packed.length();
    while (i < l) {
      int count = packed.charAt(i++);
      int value = packed.charAt(i++);
      do result[j++] = value; while (--count > 0);
    }
    return j;
  }

  /**
   * Translates DFA states to action switch labels.
   */
  private static final int [] ZZ_ACTION = zzUnpackAction();

  private static final String ZZ_ACTION_PACKED_0 =
    "\13\0\2\1\2\2\2\3\52\0\1\4\135\0\1\5"+
    "\150\0\1\5\17\0\1\6\43\0\1\7\11\0\1\10"+
    "\20\0\1\11\4\0\1\12\40\0\1\13\251\0\1\14"+
    "\13\0\1\15\3\0\1\16\5\0\1\17\72\0\1\20"+
    "\1\0\1\20\12\0\1\20\210\0\1\20\3\0\1\20"+
    "\16\0\1\20\303\0\1\21\22\0";

  private static int [] zzUnpackAction() {
    int [] result = new int[1010];
    int offset = 0;
    offset = zzUnpackAction(ZZ_ACTION_PACKED_0, offset, result);
    return result;
  }

  private static int zzUnpackAction(String packed, int offset, int [] result) {
    int i = 0;       /* index in packed string  */
    int j = offset;  /* index in unpacked array */
    int l = packed.length();
    while (i < l) {
      int count = packed.charAt(i++);
      int value = packed.charAt(i++);
      do result[j++] = value; while (--count > 0);
    }
    return j;
  }


  /**
   * Translates a state to a row index in the transition table
   */
  private static final int [] ZZ_ROWMAP = zzUnpackRowMap();

  private static final String ZZ_ROWMAP_PACKED_0 =
    "\0\0\0\60\0\140\0\220\0\300\0\360\0\u0120\0\u0150"+
    "\0\u0180\0\u01b0\0\u01e0\0\u0210\0\u0240\0\u0210\0\u0270\0\u0210"+
    "\0\u02a0\0\u02d0\0\u0300\0\u0330\0\u0360\0\u0390\0\u03c0\0\u03f0"+
    "\0\u0420\0\u0450\0\u0480\0\u04b0\0\u04e0\0\u0510\0\u0540\0\u0570"+
    "\0\u05a0\0\u05d0\0\u0600\0\u0630\0\u0660\0\u0690\0\u06c0\0\u06f0"+
    "\0\u0720\0\u0750\0\u0780\0\u07b0\0\u07e0\0\u0810\0\u0840\0\u0870"+
    "\0\u08a0\0\u08d0\0\u0900\0\u0930\0\u0960\0\u0990\0\u09c0\0\u09f0"+
    "\0\u0a20\0\u0a50\0\u0a80\0\u0210\0\u0ab0\0\u0ae0\0\u0b10\0\u0b40"+
    "\0\u0b70\0\u0ba0\0\u0bd0\0\u0c00\0\u0c30\0\u0c60\0\u0c90\0\u0cc0"+
    "\0\u0cf0\0\u0d20\0\u0d50\0\u0d80\0\u0db0\0\u0de0\0\u0e10\0\u0e40"+
    "\0\u0e70\0\u0ea0\0\u0ed0\0\u0f00\0\u0f30\0\u0f60\0\u0f90\0\u0fc0"+
    "\0\u0ff0\0\u1020\0\u1050\0\u1080\0\u10b0\0\u10e0\0\u1110\0\u1140"+
    "\0\u1170\0\u11a0\0\u11d0\0\u1200\0\u1230\0\u1260\0\u1290\0\u12c0"+
    "\0\u12f0\0\u1320\0\u1350\0\u1380\0\u13b0\0\u13e0\0\u1410\0\u1440"+
    "\0\u1470\0\u14a0\0\u14d0\0\u1500\0\u1530\0\u1560\0\u1590\0\u15c0"+
    "\0\u15f0\0\u1620\0\u1650\0\u1680\0\u16b0\0\u16e0\0\u1710\0\u1740"+
    "\0\u1770\0\u17a0\0\u17d0\0\u1800\0\u1830\0\u1860\0\u1890\0\u18c0"+
    "\0\u18f0\0\u1920\0\u1950\0\u1980\0\u19b0\0\u19e0\0\u1a10\0\u1a40"+
    "\0\u1a70\0\u1aa0\0\u1ad0\0\u1b00\0\u1b30\0\u1b60\0\u1b90\0\u1bc0"+
    "\0\u1bf0\0\u0210\0\u1c20\0\u1c50\0\u1c80\0\u1cb0\0\u1ce0\0\u1d10"+
    "\0\u1d40\0\u1d70\0\u1da0\0\u1dd0\0\u1e00\0\u1e30\0\u1e60\0\u1e90"+
    "\0\u1ec0\0\u1ef0\0\u1f20\0\u1f50\0\u1f80\0\u1fb0\0\u1fe0\0\u2010"+
    "\0\u2040\0\u2070\0\u20a0\0\u20d0\0\u2100\0\u2130\0\u2160\0\u2190"+
    "\0\u21c0\0\u21f0\0\u2220\0\u2250\0\u2280\0\u22b0\0\u22e0\0\u2310"+
    "\0\u2340\0\u2370\0\u23a0\0\u23d0\0\u2400\0\u2430\0\u2460\0\u2490"+
    "\0\u24c0\0\u24f0\0\u2520\0\u2550\0\u2580\0\u25b0\0\u25e0\0\u2610"+
    "\0\u2640\0\u2670\0\u26a0\0\u26d0\0\u2700\0\u2730\0\u2760\0\u2790"+
    "\0\u27c0\0\u27f0\0\u2820\0\u2850\0\u2880\0\u28b0\0\u28e0\0\u2910"+
    "\0\u2940\0\u2970\0\u29a0\0\u29d0\0\u2a00\0\u2a30\0\u2a60\0\u2a90"+
    "\0\u2ac0\0\u2af0\0\u2b20\0\u2b50\0\u2b80\0\u2bb0\0\u2be0\0\u2c10"+
    "\0\u2c40\0\u2c70\0\u2ca0\0\u2cd0\0\u2d00\0\u2d30\0\u2d60\0\u2d90"+
    "\0\u2dc0\0\u2df0\0\u2e20\0\u2e50\0\u2e80\0\u2eb0\0\u2ee0\0\u2f10"+
    "\0\u2f40\0\u2f70\0\u2fa0\0\u2fa0\0\u2fd0\0\u3000\0\u3030\0\u3060"+
    "\0\u3090\0\u30c0\0\u30f0\0\u3120\0\u3150\0\u3180\0\u31b0\0\u31e0"+
    "\0\u3210\0\u3240\0\u0210\0\u3270\0\u32a0\0\u32d0\0\u3300\0\u3330"+
    "\0\u3360\0\u3390\0\u33c0\0\u33f0\0\u3420\0\u3450\0\u3480\0\u34b0"+
    "\0\u34e0\0\u3510\0\u3540\0\u3570\0\u35a0\0\u35d0\0\u3600\0\u3630"+
    "\0\u3660\0\u3690\0\u36c0\0\u36f0\0\u3720\0\u3750\0\u3780\0\u37b0"+
    "\0\u37e0\0\u3810\0\u3840\0\u3870\0\u38a0\0\u38d0\0\u3900\0\u3930"+
    "\0\u3960\0\u3990\0\u39c0\0\u39f0\0\u0210\0\u3a20\0\u3a50\0\u3a80"+
    "\0\u3ab0\0\u3900\0\u3ae0\0\u3b10\0\u3b40\0\u3b70\0\u3ba0\0\u3bd0"+
    "\0\u3c00\0\u3c30\0\u3c60\0\u3ab0\0\u3c90\0\u3cc0\0\u3cf0\0\u3d20"+
    "\0\u3d50\0\u3d80\0\u3db0\0\u3de0\0\u3e10\0\u3e40\0\u3e70\0\u3ea0"+
    "\0\u3ed0\0\u3f00\0\u3f30\0\u3f60\0\u3d80\0\u3f90\0\u3fc0\0\u3ff0"+
    "\0\u4020\0\u4050\0\u4080\0\u3e70\0\u40b0\0\u40e0\0\u4110\0\u4140"+
    "\0\u4170\0\u41a0\0\u41d0\0\u4200\0\u4230\0\u4260\0\u4290\0\u42c0"+
    "\0\u42f0\0\u4320\0\u4350\0\u4380\0\u43b0\0\u43e0\0\u4410\0\u0210"+
    "\0\u4440\0\u4470\0\u44a0\0\u44d0\0\u4500\0\u4530\0\u4560\0\u4590"+
    "\0\u45c0\0\u45f0\0\u4620\0\u4650\0\u4680\0\u46b0\0\u46e0\0\u4710"+
    "\0\u4740\0\u4770\0\u47a0\0\u47d0\0\u4800\0\u4830\0\u4860\0\u4890"+
    "\0\u48c0\0\u48f0\0\u4920\0\u4950\0\u4980\0\u49b0\0\u49e0\0\u4a10"+
    "\0\u4a40\0\u4a70\0\u4aa0\0\u4ad0\0\u4b00\0\u4b30\0\u4b60\0\u4b90"+
    "\0\u4bc0\0\u4bf0\0\u4c20\0\u4c50\0\u4c80\0\u4cb0\0\u4ce0\0\u4d10"+
    "\0\u4d40\0\u4d70\0\u4da0\0\u4dd0\0\u4e00\0\u4e30\0\u4e60\0\u4e90"+
    "\0\u4ec0\0\u4ef0\0\u4f20\0\u4f50\0\u4f80\0\u4fb0\0\u4fe0\0\u5010"+
    "\0\u5040\0\u5070\0\u50a0\0\u50d0\0\u5100\0\u5130\0\u5160\0\u5190"+
    "\0\u51c0\0\u51f0\0\u5220\0\u5250\0\u5280\0\u52b0\0\u52e0\0\u5310"+
    "\0\u5340\0\u5370\0\u53a0\0\u53d0\0\u5400\0\u5430\0\u5460\0\u5490"+
    "\0\u54c0\0\u54f0\0\u5520\0\u5550\0\u5580\0\u55b0\0\u55e0\0\u5610"+
    "\0\u5640\0\u5670\0\u56a0\0\u56d0\0\u5700\0\u5730\0\u5760\0\u5790"+
    "\0\u57c0\0\u57f0\0\u5820\0\u5850\0\u5880\0\u58b0\0\u58e0\0\u5910"+
    "\0\u5940\0\u5970\0\u59a0\0\u59d0\0\u5a00\0\u5a30\0\u5a60\0\u5a90"+
    "\0\u5ac0\0\u5af0\0\u5b20\0\u5b50\0\u5b80\0\u5bb0\0\u5be0\0\u5c10"+
    "\0\u5c40\0\u5c70\0\u5ca0\0\u5cd0\0\u5d00\0\u5d30\0\u5d60\0\u5d90"+
    "\0\u5dc0\0\u5df0\0\u5e20\0\u5e50\0\u5e80\0\u5eb0\0\u5ee0\0\u5f10"+
    "\0\u5f40\0\u5f70\0\u5fa0\0\u5fd0\0\u6000\0\u6030\0\u6060\0\u6090"+
    "\0\u60c0\0\u60f0\0\u6120\0\u6150\0\u6180\0\u61b0\0\u61e0\0\u6210"+
    "\0\u6240\0\u6270\0\u62a0\0\u62d0\0\u6300\0\u6330\0\u6360\0\u6390"+
    "\0\u63c0\0\u0210\0\u63f0\0\u6420\0\u6450\0\u6480\0\u64b0\0\u64e0"+
    "\0\u6510\0\u6540\0\u6570\0\u65a0\0\u65d0\0\u0210\0\u6600\0\u6630"+
    "\0\u6660\0\u0210\0\u6690\0\u66c0\0\u66f0\0\u6720\0\u6750\0\u0210"+
    "\0\u6780\0\u67b0\0\u67e0\0\u6810\0\u6840\0\u6870\0\u68a0\0\u68d0"+
    "\0\u6900\0\u6930\0\u6960\0\u6990\0\u69c0\0\u69f0\0\u6a20\0\u6a50"+
    "\0\u6a80\0\u6ab0\0\u6ae0\0\u6b10\0\u6b40\0\u6b70\0\u6ba0\0\u6bd0"+
    "\0\u6c00\0\u6c30\0\u6c60\0\u6c90\0\u6cc0\0\u6cf0\0\u6d20\0\u6d50"+
    "\0\u6d80\0\u6db0\0\u6de0\0\u6e10\0\u6e40\0\u6e70\0\u6ea0\0\u6ed0"+
    "\0\u6f00\0\u6f30\0\u6f60\0\u6f90\0\u6fc0\0\u6ff0\0\u7020\0\u7050"+
    "\0\u7080\0\u70b0\0\u70e0\0\u7110\0\u7140\0\u7170\0\u71a0\0\u71d0"+
    "\0\u7200\0\u7230\0\u7260\0\u7290\0\u72c0\0\u7260\0\u72f0\0\u7320"+
    "\0\u7350\0\u72c0\0\u7380\0\u73b0\0\u73e0\0\u7410\0\u7440\0\u7470"+
    "\0\u74a0\0\u74d0\0\u7500\0\u7530\0\u7560\0\u7590\0\u7470\0\u75c0"+
    "\0\u75f0\0\u7620\0\u7650\0\u7680\0\u76b0\0\u76e0\0\u7710\0\u7740"+
    "\0\u7770\0\u77a0\0\u77d0\0\u7800\0\u7830\0\u7860\0\u7890\0\u78c0"+
    "\0\u78f0\0\u7920\0\u7950\0\u7980\0\u79b0\0\u79e0\0\u7a10\0\u7a40"+
    "\0\u7a70\0\u7aa0\0\u7ad0\0\u7b00\0\u7b30\0\u7b60\0\u7b90\0\u7bc0"+
    "\0\u7bf0\0\u7c20\0\u7c50\0\u7c80\0\u7cb0\0\u7ce0\0\u7d10\0\u7d40"+
    "\0\u7d70\0\u7da0\0\u7dd0\0\u7e00\0\u7e30\0\u7e60\0\u7e90\0\u7ec0"+
    "\0\u7ef0\0\u7f20\0\u7f50\0\u7f80\0\u7fb0\0\u7fe0\0\u8010\0\u8040"+
    "\0\u8070\0\u80a0\0\u80d0\0\u8100\0\u8130\0\u8160\0\u8190\0\u81c0"+
    "\0\u81f0\0\u8220\0\u8250\0\u8280\0\u82b0\0\u82e0\0\u8310\0\u8340"+
    "\0\u8370\0\u83a0\0\u83d0\0\u8400\0\u8430\0\u8460\0\u8490\0\u84c0"+
    "\0\u84f0\0\u8520\0\u8550\0\u8580\0\u85b0\0\u85e0\0\u8610\0\u8640"+
    "\0\u8670\0\u86a0\0\u86d0\0\u8700\0\u8730\0\u8760\0\u8790\0\u87c0"+
    "\0\u87f0\0\u8820\0\u8850\0\u8880\0\u88b0\0\u88e0\0\u8910\0\u8940"+
    "\0\u8970\0\u89a0\0\u89d0\0\u8a00\0\u8a30\0\u8a60\0\u8a90\0\u8ac0"+
    "\0\u8af0\0\u8b20\0\u8b50\0\u8b80\0\u8bb0\0\u8be0\0\u8c10\0\u8c40"+
    "\0\u8c70\0\u8ca0\0\u8cd0\0\u8d00\0\u8d30\0\u8d60\0\u8d90\0\u8dc0"+
    "\0\u8df0\0\u8e20\0\u8e50\0\u8e80\0\u8eb0\0\u8df0\0\u8ee0\0\u8f10"+
    "\0\u8f40\0\u8f70\0\u8fa0\0\u8eb0\0\u8fd0\0\u9000\0\u9030\0\u9060"+
    "\0\u9090\0\u90c0\0\u90f0\0\u9120\0\u9150\0\u9180\0\u91b0\0\u91e0"+
    "\0\u9210\0\u9240\0\u9270\0\u92a0\0\u92d0\0\u9120\0\u9300\0\u9330"+
    "\0\u9360\0\u9390\0\u93c0\0\u93f0\0\u9420\0\u9450\0\u9480\0\u94b0"+
    "\0\u94e0\0\u9510\0\u9540\0\u9570\0\u95a0\0\u95d0\0\u9600\0\u9630"+
    "\0\u9660\0\u9690\0\u96c0\0\u96f0\0\u9720\0\u9750\0\u9780\0\u97b0"+
    "\0\u97e0\0\u9810\0\u9840\0\u9870\0\u98a0\0\u98d0\0\u9900\0\u9930"+
    "\0\u9960\0\u9990\0\u99c0\0\u99f0\0\u9a20\0\u9a50\0\u9a80\0\u9ab0"+
    "\0\u9ae0\0\u9b10\0\u9b40\0\u9b70\0\u9ba0\0\u9bd0\0\u9c00\0\u9c30"+
    "\0\u9c60\0\u9c90\0\u9cc0\0\u9cf0\0\u9d20\0\u9d50\0\u9d80\0\u9db0"+
    "\0\u9de0\0\u9e10\0\u9e40\0\u9e70\0\u9ea0\0\u9ed0\0\u9f00\0\u9f30"+
    "\0\u9f60\0\u9f90\0\u9fc0\0\u9ff0\0\ua020\0\ua050\0\ua080\0\ua0b0"+
    "\0\ua0e0\0\ua110\0\ua140\0\ua170\0\ua1a0\0\ua1d0\0\ua200\0\ua230"+
    "\0\ua260\0\ua290\0\ua2c0\0\ua2f0\0\ua320\0\ua350\0\ua380\0\ua3b0"+
    "\0\ua3e0\0\ua410\0\ua440\0\ua470\0\ua4a0\0\ua4d0\0\ua500\0\ua530"+
    "\0\ua560\0\ua590\0\ua5c0\0\ua5f0\0\ua620\0\ua650\0\ua680\0\ua6b0"+
    "\0\ua6e0\0\ua710\0\ua740\0\ua770\0\ua7a0\0\ua7d0\0\ua800\0\ua830"+
    "\0\ua860\0\ua890\0\ua8c0\0\ua8f0\0\ua920\0\ua950\0\ua980\0\ua9b0"+
    "\0\ua9e0\0\uaa10\0\uaa40\0\uaa70\0\uaaa0\0\uaad0\0\uab00\0\uab30"+
    "\0\uab60\0\uab90\0\uabc0\0\uabf0\0\uac20\0\uac50\0\uac80\0\uacb0"+
    "\0\uace0\0\uad10\0\uad40\0\uad70\0\uada0\0\uadd0\0\uae00\0\uae30"+
    "\0\uae60\0\uae90\0\uaec0\0\uaef0\0\uaf20\0\uaf50\0\uaf80\0\uafb0"+
    "\0\uafe0\0\ub010\0\ub040\0\ub070\0\ub0a0\0\ub0d0\0\ub100\0\ub130"+
    "\0\ub160\0\ub190\0\ub1c0\0\ub1f0\0\ub220\0\ub250\0\ub280\0\ub2b0"+
    "\0\ub2e0\0\ub310\0\ub340\0\ub370\0\ub3a0\0\ub3d0\0\ub400\0\ub430"+
    "\0\ub460\0\ub490\0\ub4c0\0\ub4f0\0\ub520\0\ub550\0\ub580\0\u0210"+
    "\0\ub5b0\0\ub5e0\0\ub610\0\ub640\0\ub670\0\ub6a0\0\ub6d0\0\ub700"+
    "\0\ub730\0\ub760\0\ub790\0\ub7c0\0\ub7f0\0\ub820\0\ub850\0\ub880"+
    "\0\ub8b0\0\ub8e0";

  private static int [] zzUnpackRowMap() {
    int [] result = new int[1010];
    int offset = 0;
    offset = zzUnpackRowMap(ZZ_ROWMAP_PACKED_0, offset, result);
    return result;
  }

  private static int zzUnpackRowMap(String packed, int offset, int [] result) {
    int i = 0;  /* index in packed string  */
    int j = offset;  /* index in unpacked array */
    int l = packed.length() - 1;
    while (i < l) {
      int high = packed.charAt(i++) << 16;
      result[j++] = high | packed.charAt(i++);
    }
    return j;
  }

  /**
   * The transition table of the DFA
   */
  private static final int [] ZZ_TRANS = zzUnpacktrans();

  private static final String ZZ_TRANS_PACKED_0 =
    "\34\14\1\15\23\14\34\16\1\17\23\16\34\20\1\21"+
    "\23\20\34\0\1\22\60\0\1\23\56\0\1\24\60\0"+
    "\1\25\56\0\1\26\60\0\1\27\56\0\1\30\60\0"+
    "\1\31\125\0\1\32\23\0\1\32\16\0\1\33\74\0"+
    "\1\34\23\0\1\34\33\0\1\35\23\0\1\35\35\0"+
    "\1\36\23\0\1\36\31\0\1\37\23\0\1\37\35\0"+
    "\1\40\23\0\1\40\31\0\1\41\23\0\1\41\35\0"+
    "\1\42\23\0\1\42\31\0\1\43\23\0\1\43\35\0"+
    "\1\44\23\0\1\44\30\0\1\45\23\0\1\45\34\0"+
    "\1\46\23\0\1\46\32\0\1\47\23\0\1\47\33\0"+
    "\1\50\23\0\1\50\33\0\1\51\23\0\1\51\33\0"+
    "\1\52\23\0\1\52\33\0\1\53\23\0\1\53\33\0"+
    "\1\54\23\0\1\54\33\0\1\55\23\0\1\55\33\0"+
    "\1\56\23\0\1\56\33\0\1\57\23\0\1\57\36\0"+
    "\1\60\23\0\1\60\30\0\1\61\23\0\1\61\36\0"+
    "\1\62\23\0\1\62\33\0\1\63\23\0\1\63\31\0"+
    "\1\64\23\0\1\64\35\0\1\65\23\0\1\65\31\0"+
    "\1\66\23\0\1\66\35\0\1\67\23\0\1\67\31\0"+
    "\1\70\23\0\1\70\35\0\1\71\23\0\1\71\31\0"+
    "\1\72\23\0\1\72\20\0\1\73\74\0\1\74\23\0"+
    "\1\74\16\0\1\75\57\0\1\76\55\0\1\77\61\0"+
    "\1\100\55\0\1\101\61\0\1\102\55\0\1\103\61\0"+
    "\1\104\55\0\1\105\63\0\1\106\21\107\2\0\1\107"+
    "\1\110\32\0\1\111\1\112\1\113\4\112\1\114\1\112"+
    "\1\115\10\112\2\0\1\112\1\116\1\0\1\117\3\0"+
    "\1\120\1\0\1\121\22\0\1\122\24\0\1\122\54\0"+
    "\1\123\37\0\1\124\24\0\1\124\52\0\1\125\46\0"+
    "\1\126\23\0\1\126\44\0\1\127\44\0\1\130\23\0"+
    "\1\130\46\0\1\131\33\0\1\132\1\0\16\107\1\133"+
    "\3\107\2\0\1\107\15\0\1\134\13\0\1\132\1\0"+
    "\22\107\2\0\1\107\51\0\1\134\23\0\1\134\13\0"+
    "\1\135\1\0\16\112\1\136\3\112\2\0\1\112\15\0"+
    "\1\137\13\0\1\135\1\0\22\112\2\0\1\112\31\0"+
    "\1\135\1\0\14\112\1\140\5\112\2\0\1\112\13\0"+
    "\1\141\15\0\1\135\1\0\20\112\1\142\1\112\2\0"+
    "\1\112\17\0\1\143\11\0\1\135\1\0\4\112\1\144"+
    "\15\112\2\0\1\112\3\0\1\145\45\0\1\137\23\0"+
    "\1\137\31\0\1\141\23\0\1\141\37\0\1\143\23\0"+
    "\1\143\17\0\1\145\23\0\1\145\45\0\1\146\23\0"+
    "\1\146\3\0\34\147\1\0\23\147\26\0\1\150\23\0"+
    "\1\150\5\0\34\151\1\0\23\151\16\0\1\152\23\0"+
    "\1\152\15\0\34\153\1\0\23\153\32\0\1\154\23\0"+
    "\1\154\1\0\34\155\1\0\23\155\2\132\2\0\4\132"+
    "\1\156\23\132\2\0\22\132\10\0\1\132\1\0\20\107"+
    "\1\157\1\107\2\0\1\107\17\0\1\160\33\0\1\160"+
    "\23\0\1\160\1\0\2\135\2\0\4\135\1\161\23\135"+
    "\2\0\22\135\10\0\1\135\1\0\20\112\1\162\1\112"+
    "\2\0\1\112\17\0\1\163\33\0\1\163\23\0\1\163"+
    "\11\0\1\135\1\0\12\112\1\164\7\112\2\0\1\112"+
    "\11\0\1\165\33\0\1\165\23\0\1\165\17\0\1\135"+
    "\1\0\4\112\1\166\15\112\2\0\1\112\3\0\1\167"+
    "\33\0\1\167\23\0\1\167\25\0\1\135\1\0\6\112"+
    "\1\170\11\112\1\171\1\112\2\0\1\112\5\0\1\172"+
    "\11\0\1\173\21\0\1\172\11\0\1\173\11\0\1\172"+
    "\11\0\1\173\33\0\1\174\23\0\1\174\1\0\34\147"+
    "\1\0\1\175\22\147\24\0\1\176\23\0\1\176\7\0"+
    "\34\151\1\0\1\177\22\151\32\0\1\200\23\0\1\200"+
    "\1\0\34\153\1\0\1\201\22\153\16\0\1\202\23\0"+
    "\1\202\15\0\34\155\1\0\1\203\22\155\7\0\1\204"+
    "\60\0\1\132\1\0\7\107\1\205\12\107\2\0\1\107"+
    "\6\0\1\206\33\0\1\206\23\0\1\206\21\0\1\207"+
    "\60\0\1\135\1\0\7\112\1\210\12\112\2\0\1\112"+
    "\6\0\1\211\33\0\1\211\23\0\1\211\22\0\1\135"+
    "\1\0\12\112\1\212\7\112\2\0\1\112\11\0\1\213"+
    "\33\0\1\213\23\0\1\213\17\0\1\135\1\0\12\112"+
    "\1\214\7\112\2\0\1\112\11\0\1\215\33\0\1\215"+
    "\23\0\1\215\17\0\1\135\1\0\22\112\2\0\1\216"+
    "\31\0\1\135\1\0\20\112\1\217\1\112\2\0\1\112"+
    "\17\0\1\220\37\0\1\221\53\0\1\220\23\0\1\220"+
    "\22\0\1\222\23\0\1\222\12\0\7\147\1\223\24\147"+
    "\1\0\1\175\22\147\24\0\1\224\23\0\1\224\7\0"+
    "\7\151\1\225\24\151\1\0\1\177\22\151\32\0\1\226"+
    "\23\0\1\226\1\0\7\153\1\227\24\153\1\0\1\201"+
    "\22\153\24\0\1\230\23\0\1\230\7\0\7\155\1\231"+
    "\24\155\1\0\1\203\22\155\7\0\1\204\25\0\1\232"+
    "\32\0\1\132\1\0\2\107\1\233\17\107\2\0\1\107"+
    "\2\0\1\234\32\0\1\234\24\0\1\234\25\0\1\207"+
    "\25\0\1\235\32\0\1\135\1\0\2\112\1\236\17\112"+
    "\2\0\1\112\2\0\1\237\32\0\1\237\24\0\1\237"+
    "\26\0\1\135\1\0\1\240\21\112\2\0\1\112\1\241"+
    "\32\0\1\241\24\0\1\241\30\0\1\242\1\0\22\112"+
    "\2\0\1\112\31\0\1\242\57\0\1\135\1\0\1\243"+
    "\21\112\2\0\1\112\1\244\30\0\1\135\1\0\4\112"+
    "\1\245\15\112\2\0\1\112\3\0\1\246\33\0\1\246"+
    "\23\0\1\246\27\0\1\244\24\0\1\244\34\0\1\247"+
    "\24\0\1\247\16\0\7\147\1\223\1\250\23\147\1\0"+
    "\1\175\22\147\12\0\1\230\24\0\1\230\20\0\7\151"+
    "\1\225\1\251\23\151\1\0\1\177\22\151\16\0\1\252"+
    "\23\0\1\252\15\0\7\153\1\227\1\253\23\153\1\0"+
    "\1\201\22\153\10\0\1\254\47\0\7\155\1\231\1\255"+
    "\23\155\1\0\1\203\22\155\10\0\1\132\1\0\11\107"+
    "\1\256\10\107\2\0\1\107\10\0\1\257\33\0\1\257"+
    "\23\0\1\257\10\0\34\260\1\0\23\260\10\0\1\135"+
    "\1\0\11\112\1\261\10\112\2\0\1\112\10\0\1\262"+
    "\33\0\1\262\23\0\1\262\20\0\1\263\1\0\22\112"+
    "\2\0\1\112\31\0\1\263\47\0\2\242\2\0\4\242"+
    "\1\264\23\242\2\0\22\242\10\0\1\135\1\0\11\112"+
    "\1\265\10\112\2\0\1\112\10\0\1\266\33\0\1\266"+
    "\23\0\1\266\20\0\1\135\1\0\16\112\1\267\3\112"+
    "\2\0\1\112\15\0\1\270\33\0\1\270\23\0\1\270"+
    "\26\0\1\271\23\0\1\271\10\0\2\250\2\147\4\250"+
    "\1\272\23\250\1\0\1\175\22\250\2\251\2\151\4\251"+
    "\1\273\23\251\1\0\1\177\22\251\30\0\1\230\23\0"+
    "\1\230\3\0\2\253\2\153\4\253\1\274\23\253\1\0"+
    "\1\201\22\253\2\254\2\0\4\254\1\275\23\254\2\0"+
    "\22\254\2\255\2\155\4\255\1\276\23\255\1\0\1\203"+
    "\22\255\10\0\1\132\1\0\4\107\1\277\15\107\2\0"+
    "\1\107\3\0\1\300\33\0\1\300\23\0\1\300\15\0"+
    "\34\260\1\301\23\260\10\0\1\135\1\0\4\112\1\302"+
    "\15\112\2\0\1\112\3\0\1\303\33\0\1\303\23\0"+
    "\1\303\15\0\2\263\2\0\4\263\1\304\23\263\2\0"+
    "\22\263\7\0\1\305\60\0\1\135\1\0\7\112\1\306"+
    "\12\112\2\0\1\112\6\0\1\307\33\0\1\307\23\0"+
    "\1\307\22\0\1\310\1\0\22\112\2\0\1\112\31\0"+
    "\1\310\65\0\1\230\23\0\1\230\15\0\16\147\1\311"+
    "\15\147\1\0\1\175\4\147\1\311\15\147\12\151\1\312"+
    "\21\151\1\0\1\177\1\151\1\312\20\151\12\153\1\313"+
    "\15\153\1\314\3\153\1\0\1\201\1\153\1\313\14\153"+
    "\1\314\3\153\7\0\1\315\50\0\12\155\1\316\11\155"+
    "\1\317\3\155\1\320\3\155\1\0\1\203\1\155\1\316"+
    "\10\155\1\317\3\155\1\320\3\155\10\0\1\321\1\0"+
    "\22\107\2\0\1\107\31\0\1\322\55\0\1\323\61\0"+
    "\1\324\1\0\22\112\2\0\1\112\31\0\1\324\56\0"+
    "\1\325\57\0\1\305\25\0\1\326\32\0\1\135\1\0"+
    "\1\327\21\112\2\0\1\112\1\330\32\0\1\330\24\0"+
    "\1\330\20\0\2\310\2\0\4\310\1\331\23\310\2\0"+
    "\22\310\23\147\1\332\10\147\1\0\1\175\11\147\1\332"+
    "\10\147\24\151\1\333\7\151\1\0\1\177\12\151\1\333"+
    "\7\151\24\153\1\334\7\153\1\0\1\201\12\153\1\334"+
    "\25\153\1\335\15\153\1\0\1\201\4\153\1\335\15\153"+
    "\7\0\1\315\25\0\1\336\22\0\24\155\1\337\7\155"+
    "\1\0\1\203\12\155\1\337\25\155\1\340\15\155\1\0"+
    "\1\203\4\155\1\340\33\155\1\341\15\155\1\0\1\203"+
    "\4\155\1\341\15\155\2\321\2\0\4\321\1\342\23\321"+
    "\2\0\22\321\2\322\2\0\4\322\1\343\23\322\2\0"+
    "\22\322\23\0\1\344\23\0\1\344\10\0\2\324\2\0"+
    "\4\324\1\345\23\324\2\0\22\324\7\0\1\325\25\0"+
    "\1\346\22\0\34\347\1\0\23\347\10\0\1\135\1\0"+
    "\17\112\1\350\2\112\2\0\1\112\16\0\1\351\33\0"+
    "\1\351\23\0\1\351\11\0\1\352\50\0\14\147\1\353"+
    "\17\147\1\0\1\175\3\147\1\353\16\147\24\151\1\354"+
    "\7\151\1\0\1\177\12\151\1\354\7\151\24\153\1\355"+
    "\7\153\1\0\1\201\12\153\1\355\41\153\1\356\1\153"+
    "\1\0\1\201\20\153\1\356\1\153\34\357\1\0\23\357"+
    "\24\155\1\360\7\155\1\0\1\203\12\155\1\360\41\155"+
    "\1\361\1\155\1\0\1\203\20\155\1\361\33\155\1\362"+
    "\1\155\1\0\1\203\20\155\1\362\1\155\7\0\1\363"+
    "\57\0\1\364\72\0\1\365\23\0\1\365\20\0\1\366"+
    "\50\0\34\367\1\0\23\367\34\347\1\370\23\347\10\0"+
    "\1\371\1\0\22\112\2\0\1\112\31\0\1\371\56\0"+
    "\1\352\25\0\1\372\22\0\21\147\1\373\12\147\1\0"+
    "\1\175\7\147\1\373\12\147\26\151\1\374\5\151\1\0"+
    "\1\177\14\151\1\374\5\151\26\153\1\375\5\153\1\0"+
    "\1\201\14\153\1\375\37\153\1\376\1\153\1\0\1\201"+
    "\20\153\1\376\1\153\34\357\1\377\23\357\26\155\1\u0100"+
    "\5\155\1\0\1\203\14\155\1\u0100\26\155\1\u0101\12\155"+
    "\1\0\1\203\7\155\1\u0101\44\155\1\u0102\1\155\1\0"+
    "\1\203\20\155\1\u0102\1\155\7\0\1\363\25\0\1\u0103"+
    "\31\0\1\364\25\0\1\u0104\47\0\1\u0105\23\0\1\u0105"+
    "\15\0\1\366\25\0\1\u0106\22\0\34\367\1\u0107\23\367"+
    "\6\0\1\u0108\51\0\2\371\2\0\4\371\1\u0109\23\371"+
    "\2\0\22\371\34\u010a\1\0\23\u010a\32\147\1\u010b\1\147"+
    "\1\0\1\175\20\147\1\u010b\1\147\14\151\1\u010c\17\151"+
    "\1\0\1\177\3\151\1\u010c\16\151\14\153\1\u010d\17\153"+
    "\1\0\1\201\3\153\1\u010d\34\153\1\u010e\15\153\1\0"+
    "\1\201\4\153\1\u010e\15\153\6\0\1\u010f\51\0\14\155"+
    "\1\u0101\17\155\1\0\1\203\3\155\1\u0101\26\155\1\u0110"+
    "\23\155\1\0\1\203\40\155\1\u0111\15\155\1\0\1\203"+
    "\4\155\1\u0111\15\155\34\u0112\1\0\23\u0112\35\0\1\u0113"+
    "\22\0\34\u0114\1\0\23\u0114\6\0\1\u0115\74\0\1\u0116"+
    "\23\0\1\u0116\17\0\1\u0117\50\0\34\u010a\1\u0118\23\u010a"+
    "\30\147\1\u0119\3\147\1\0\1\175\16\147\1\u0119\3\147"+
    "\10\151\1\u011a\23\151\1\0\1\177\22\151\10\153\1\u011b"+
    "\23\153\1\0\1\201\45\153\1\u010d\10\153\1\0\1\201"+
    "\11\153\1\u010d\10\153\23\0\1\u011c\23\0\1\u011c\10\0"+
    "\25\155\1\u011d\6\155\1\0\1\203\13\155\1\u011d\31\155"+
    "\1\u0101\10\155\1\0\1\203\11\155\1\u0101\10\155\34\u0112"+
    "\1\u011e\23\u0112\34\u0114\1\u011f\23\u0114\23\0\1\u0120\23\0"+
    "\1\u0120\32\0\1\u0121\23\0\1\u0121\20\0\1\u0117\25\0"+
    "\1\u0122\30\0\1\u0123\51\0\12\147\1\u0124\21\147\1\0"+
    "\1\175\1\147\1\u0124\20\147\25\151\1\u0125\6\151\1\0"+
    "\1\177\13\151\1\u0125\6\151\25\153\1\u0126\6\153\1\0"+
    "\1\201\13\153\1\u0126\6\153\22\0\1\u0127\23\0\1\u0127"+
    "\11\0\22\155\1\u0128\11\155\1\0\1\203\10\155\1\u0128"+
    "\11\155\6\0\1\u0129\57\0\1\u012a\73\0\1\u012b\23\0"+
    "\1\u012b\36\0\1\u012c\23\0\1\u012c\6\0\34\u012d\1\0"+
    "\23\u012d\23\0\1\u012e\23\0\1\u012e\10\0\10\147\1\u012f"+
    "\23\147\1\0\1\175\22\147\22\151\1\u0130\11\151\1\0"+
    "\1\177\10\151\1\u0130\11\151\22\153\1\u0131\11\153\1\0"+
    "\1\201\10\153\1\u0131\11\153\25\0\1\u0132\23\0\1\u0132"+
    "\6\0\23\155\1\u0133\10\155\1\0\1\203\11\155\1\u0133"+
    "\10\155\23\0\1\u0134\23\0\1\u0134\33\0\1\u0135\23\0"+
    "\1\u0135\35\0\1\u0136\23\0\1\u0136\43\0\1\u0137\22\0"+
    "\34\u012d\1\u0138\23\u012d\22\0\1\u0139\23\0\1\u0139\11\0"+
    "\25\147\1\u013a\6\147\1\0\1\175\13\147\1\u013a\6\147"+
    "\23\151\1\u013b\10\151\1\0\1\177\11\151\1\u013b\10\151"+
    "\23\153\1\u013c\10\153\1\0\1\201\11\153\1\u013c\10\153"+
    "\35\0\1\u013d\22\0\34\155\1\u013e\1\203\22\155\22\0"+
    "\1\u013f\23\0\1\u013f\33\0\1\u0140\23\0\1\u0140\46\0"+
    "\1\u0141\23\0\2\u0142\1\0\1\u0143\1\u0142\26\0\1\u0144"+
    "\1\0\1\u0142\27\0\1\u0145\76\0\1\u0146\23\0\1\u0146"+
    "\6\0\22\147\1\u0147\11\147\1\0\1\175\10\147\1\u0147"+
    "\11\147\34\151\1\u013e\1\177\22\151\34\153\1\u013e\1\201"+
    "\22\153\1\0\2\u013e\2\0\1\u013e\3\0\1\u0148\23\0"+
    "\1\u0149\1\u013e\46\0\1\u014a\23\0\1\u014a\33\0\1\u014b"+
    "\23\0\1\u014b\7\0\2\u014c\1\0\1\u014d\1\u014c\26\0"+
    "\1\u014e\1\0\1\u014c\46\0\1\u014f\23\0\1\u014f\31\0"+
    "\1\u0150\23\0\1\u0150\33\0\1\u0151\23\0\1\u0151\45\0"+
    "\1\u0152\22\0\23\147\1\u0153\10\147\1\0\1\175\11\147"+
    "\1\u0153\10\147\27\0\1\u0154\23\0\1\u0154\31\0\1\u0155"+
    "\23\0\1\u0155\43\0\1\u0156\57\0\1\u0157\47\0\1\u0158"+
    "\23\0\1\u0158\31\0\1\u0159\23\0\1\u0159\23\0\1\u015a"+
    "\24\0\1\u015a\41\0\1\u015b\23\0\1\u015b\33\0\1\u015c"+
    "\23\0\1\u015c\12\0\2\u015d\1\0\1\u015e\1\u015d\26\0"+
    "\1\u015f\1\0\1\u015d\21\0\34\147\1\u013e\1\175\22\147"+
    "\31\0\1\u0160\23\0\1\u0160\24\0\1\u0161\23\0\1\u0161"+
    "\12\0\2\u0156\1\0\1\u0162\1\u0156\26\0\1\u0163\1\0"+
    "\1\u0156\22\0\2\u0164\1\0\1\u0165\1\u0164\26\0\1\u0166"+
    "\1\0\1\u0164\34\0\1\u0167\24\0\1\u0167\41\0\1\u0168"+
    "\23\0\1\u0168\42\0\1\u0169\23\0\1\u0169\27\0\1\u016a"+
    "\23\0\1\u016a\33\0\1\u016b\23\0\1\u016b\33\0\1\u016c"+
    "\23\0\1\u016c\31\0\1\u016d\23\0\1\u016d\23\0\1\u016e"+
    "\24\0\1\u016e\42\0\1\u016f\23\0\1\u016f\35\0\1\u0170"+
    "\23\0\1\u0170\31\0\1\u0171\23\0\1\u0171\35\0\1\u0172"+
    "\23\0\1\u0172\31\0\1\u0173\23\0\1\u0173\41\0\1\u0174"+
    "\23\0\1\u0174\27\0\1\u0175\23\0\1\u0175\35\0\1\u0176"+
    "\23\0\1\u0176\14\0\1\u0177\104\0\1\u0178\35\0\1\u0179"+
    "\24\0\1\u0179\41\0\1\u017a\23\0\1\u017a\36\0\1\u017b"+
    "\23\0\1\u017b\14\0\1\u017c\64\0\1\u017d\24\0\1\u017d"+
    "\41\0\1\u017e\23\0\1\u017e\24\0\1\u017f\24\0\1\u017f"+
    "\41\0\1\u0180\23\0\1\u0180\40\0\1\u0181\23\0\1\u0181"+
    "\14\0\1\u0182\60\0\1\u0142\62\0\1\u0183\4\0\1\u0184"+
    "\1\0\1\u0185\5\0\1\u0186\7\0\1\u0183\3\0\1\u0184"+
    "\1\0\1\u0185\5\0\1\u0186\33\0\1\u0187\23\0\1\u0187"+
    "\27\0\1\u0188\23\0\1\u0188\12\0\1\u013e\107\0\1\u0189"+
    "\54\0\1\u018a\23\0\1\u018a\27\0\1\u018b\23\0\1\u018b"+
    "\37\0\1\u018c\23\0\1\u018c\27\0\1\u018d\23\0\1\u018d"+
    "\17\0\1\u014c\62\0\1\u018e\14\0\1\u018f\7\0\1\u018e"+
    "\13\0\1\u018f\30\0\1\u0190\23\0\1\u0190\37\0\1\u0191"+
    "\23\0\1\u0191\17\0\1\u0192\23\0\1\u0192\47\0\1\u0193"+
    "\23\0\1\u0193\30\0\1\u0194\23\0\1\u0194\14\0\1\u0195"+
    "\47\0\34\u0196\1\0\23\u0196\27\0\1\u0197\23\0\1\u0197"+
    "\14\0\1\u0198\76\0\1\u0199\23\0\1\u0199\14\0\1\u019a"+
    "\75\0\1\u019b\23\0\1\u019b\37\0\1\u019c\23\0\1\u019c"+
    "\25\0\1\u019d\23\0\1\u019d\25\0\1\u019e\23\0\1\u019e"+
    "\47\0\1\u019f\23\0\1\u019f\30\0\1\u01a0\23\0\1\u01a0"+
    "\15\0\1\u015d\62\0\1\u01a1\6\0\1\u01a2\5\0\1\u01a3"+
    "\7\0\1\u01a1\5\0\1\u01a2\5\0\1\u01a3\2\0\34\u0196"+
    "\1\0\1\u01a4\22\u0196\11\0\1\u0156\60\0\1\110\10\0"+
    "\1\u01a5\5\0\1\u01a6\5\0\1\110\7\0\1\u01a5\5\0"+
    "\1\u01a6\13\0\1\u0164\60\0\1\u01a7\16\0\1\u01a8\5\0"+
    "\1\u01a7\15\0\1\u01a8\26\0\1\u01a9\23\0\1\u01a9\36\0"+
    "\1\u01aa\23\0\1\u01aa\30\0\1\u01ab\23\0\1\u01ab\33\0"+
    "\1\u01ac\23\0\1\u01ac\41\0\1\u01ad\23\0\1\u01ad\34\0"+
    "\1\u01ae\23\0\1\u01ae\26\0\1\u01af\23\0\1\u01af\23\0"+
    "\1\u01b0\23\0\1\u01b0\47\0\1\u01b1\23\0\1\u01b1\1\0"+
    "\7\u0196\1\u01b2\24\u0196\1\0\1\u01a4\22\u0196\16\0\1\u01b3"+
    "\23\0\1\u01b3\47\0\1\u01b4\23\0\1\u01b4\31\0\1\u01b5"+
    "\23\0\1\u01b5\35\0\1\u01b6\23\0\1\u01b6\25\0\1\u01b7"+
    "\23\0\1\u01b7\42\0\1\u01b8\23\0\1\u01b8\12\0\1\u01ac"+
    "\24\0\1\u01ac\30\0\1\u01b9\65\0\1\u01ba\23\0\1\u01ba"+
    "\25\0\1\u01bb\73\0\1\u01bc\23\0\1\u01bc\41\0\1\u01bd"+
    "\23\0\1\u01bd\30\0\1\u01be\23\0\1\u01be\4\0\7\u0196"+
    "\1\u01b2\1\u01bf\23\u0196\1\0\1\u01a4\22\u0196\20\0\1\u01c0"+
    "\23\0\1\u01c0\42\0\1\u01c1\23\0\1\u01c1\36\0\1\u01c2"+
    "\23\0\1\u01c2\30\0\1\u01c3\23\0\1\u01c3\16\0\1\u01c4"+
    "\24\0\1\u01c4\30\0\1\u01c5\47\0\2\u01b9\2\0\4\u01b9"+
    "\1\u01c6\23\u01b9\2\0\22\u01b9\30\0\1\u01ac\23\0\1\u01ac"+
    "\3\0\2\u01bb\2\0\4\u01bb\1\u01c7\23\u01bb\2\0\22\u01bb"+
    "\24\0\1\u01c8\23\0\1\u01c8\41\0\1\u01c9\23\0\1\u01c9"+
    "\34\0\1\u01ca\23\0\1\u01ca\2\u01bf\2\u0196\4\u01bf\1\u01cb"+
    "\23\u01bf\1\0\1\u01a4\22\u01bf\36\0\1\u01cc\54\0\1\300"+
    "\23\0\1\300\21\0\1\u01cd\23\0\1\u01cd\45\0\1\u01ce"+
    "\23\0\1\u01ce\10\0\1\u01cf\47\0\2\u01c5\2\0\4\u01c5"+
    "\1\u01d0\23\u01c5\2\0\22\u01c5\7\0\1\u01d1\57\0\1\u01d2"+
    "\62\0\1\u01d3\24\0\1\u01d3\36\0\1\u01d4\23\0\1\u01d4"+
    "\25\0\1\u01d5\47\0\33\u0196\1\u01d6\1\0\1\u01a4\21\u0196"+
    "\1\u01d6\12\0\1\u01d7\24\0\1\u01d7\34\0\1\u01d8\24\0"+
    "\1\u01d8\26\0\1\u01d9\47\0\2\u01cf\2\0\4\u01cf\1\u01da"+
    "\23\u01cf\2\0\22\u01cf\7\0\1\u01db\57\0\1\u01d1\25\0"+
    "\1\u01dc\31\0\1\u01d2\25\0\1\u01dd\32\0\1\u01de\77\0"+
    "\1\u01d3\23\0\1\u01d3\3\0\2\u01d5\2\0\4\u01d5\1\u01df"+
    "\23\u01d5\2\0\22\u01d5\27\u0196\1\u01e0\4\u0196\1\0\1\u01a4"+
    "\15\u0196\1\u01e0\4\u0196\23\0\1\u01e1\23\0\1\u01e1\33\0"+
    "\1\u01e2\23\0\1\u01e2\10\0\2\u01d9\2\0\4\u01d9\1\u01e3"+
    "\23\u01d9\2\0\22\u01d9\7\0\1\u01e4\57\0\1\u01db\25\0"+
    "\1\u01e5\22\0\34\u01e6\1\0\23\u01e6\34\u01e7\1\0\23\u01e7"+
    "\2\u01de\2\0\4\u01de\1\u01e8\23\u01de\2\0\22\u01de\7\0"+
    "\1\u01e9\50\0\32\u0196\1\u01ea\1\u0196\1\0\1\u01a4\20\u0196"+
    "\1\u01ea\1\u0196\21\0\1\u01eb\23\0\1\u01eb\30\0\1\u01ec"+
    "\23\0\1\u01ec\24\0\1\u01ed\57\0\1\u01e4\25\0\1\u01ee"+
    "\22\0\34\u01ef\1\0\23\u01ef\34\u01e6\1\u01f0\23\u01e6\34\u01e7"+
    "\1\u01f1\23\u01e7\7\0\1\u01f2\57\0\1\u01e9\25\0\1\u01f3"+
    "\22\0\31\u0196\1\u01f4\2\u0196\1\0\1\u01a4\17\u0196\1\u01f4"+
    "\2\u0196\12\0\1\u01f5\24\0\1\u01f5\30\0\1\u01f6\56\0"+
    "\1\u01ed\25\0\1\u01f7\22\0\34\u01f8\1\0\23\u01f8\34\u01ef"+
    "\1\u01f9\23\u01ef\6\0\1\u01fa\57\0\1\u01fb\60\0\1\u01f2"+
    "\25\0\1\u01fc\22\0\34\u01fd\1\0\23\u01fd\10\u0196\1\u01fe"+
    "\23\u0196\1\0\1\u01a4\22\u0196\31\0\1\u01ff\23\0\1\u01ff"+
    "\2\0\2\u01f6\2\0\4\u01f6\1\u0200\23\u01f6\2\0\22\u01f6"+
    "\34\u0201\1\0\23\u0201\34\u01f8\1\u0202\23\u01f8\6\0\1\u0203"+
    "\74\0\1\u0204\23\0\1\u0204\33\0\1\u0205\23\0\1\u0205"+
    "\10\0\34\u0206\1\0\23\u0206\34\u01fd\1\u0207\23\u01fd\25\u0196"+
    "\1\u0208\6\u0196\1\0\1\u01a4\13\u0196\1\u0208\6\u0196\10\0"+
    "\1\u0209\56\0\1\u020a\50\0\34\u0201\1\u020b\23\u0201\6\0"+
    "\1\u020c\74\0\1\u020d\23\0\1\u020d\32\0\1\u020e\23\0"+
    "\1\u020e\33\0\1\u020f\23\0\1\u020f\11\0\34\u0206\1\u0210"+
    "\23\u0206\6\0\1\u0211\51\0\22\u0196\1\u0212\11\u0196\1\0"+
    "\1\u01a4\10\u0196\1\u0212\11\u0196\2\u0209\2\0\4\u0209\1\u0213"+
    "\23\u0209\2\0\22\u0209\7\0\1\u020a\25\0\1\u0214\30\0"+
    "\1\u0215\74\0\1\u0216\23\0\1\u0216\32\0\1\u0217\23\0"+
    "\1\u0217\36\0\1\u0218\23\0\1\u0218\33\0\1\u0219\23\0"+
    "\1\u0219\14\0\1\u021a\74\0\1\u021b\23\0\1\u021b\10\0"+
    "\23\u0196\1\u021c\10\u0196\1\0\1\u01a4\11\u0196\1\u021c\10\u0196"+
    "\7\0\1\u021d\50\0\34\u021e\1\0\23\u021e\23\0\1\u021f"+
    "\23\0\1\u021f\32\0\1\u0220\23\0\1\u0220\36\0\1\u0221"+
    "\23\0\1\u0221\43\0\1\u0222\57\0\1\u0142\45\0\1\u0223"+
    "\23\0\1\u0223\32\0\1\u0224\23\0\1\u0224\11\0\34\u0196"+
    "\1\u013e\1\u01a4\22\u0196\7\0\1\u021d\25\0\1\u0225\22\0"+
    "\34\u021e\1\u0226\23\u021e\22\0\1\u0227\23\0\1\u0227\36\0"+
    "\1\u0228\23\0\1\u0228\43\0\1\u014c\44\0\1\u0229\23\0"+
    "\1\u0229\36\0\1\u022a\23\0\1\u022a\6\0\34\u022b\1\0"+
    "\23\u022b\6\0\1\u022c\76\0\1\u022d\23\0\1\u022d\43\0"+
    "\1\u022e\47\0\1\u022f\23\0\1\u022f\43\0\1\u015d\22\0"+
    "\34\u022b\1\u0230\23\u022b\23\0\1\u0231\23\0\1\u0231\45\0"+
    "\1\u0164\57\0\1\u0232\30\0\1\u0233\73\0\1\u0234\23\0"+
    "\1\u0234\34\0\1\u0235\23\0\1\u0235\35\0\1\u0236\23\0"+
    "\1\u0236\30\0\1\u0237\23\0\1\u0237\46\0\1\u0238\47\0"+
    "\1\u0239\23\0\1\u0239\43\0\1\u023a\23\0\2\u023a\1\0"+
    "\1\u023b\1\u023a\26\0\1\u023c\1\0\1\u023a\46\0\1\u023d"+
    "\23\0\1\u023d\31\0\1\u023e\23\0\1\u023e\23\0\1\u023f"+
    "\24\0\1\u023f\41\0\1\u0240\23\0\1\u0240\42\0\1\u0241"+
    "\23\0\1\u0241\27\0\1\u0242\23\0\1\u0242\35\0\1\u0243"+
    "\23\0\1\u0243\14\0\1\u0244\60\0\1\u023a\62\0\1\u0245"+
    "\4\0\1\u0246\1\0\1\u0247\5\0\1\u0248\7\0\1\u0245"+
    "\3\0\1\u0246\1\0\1\u0247\5\0\1\u0248\30\0\1\u0249"+
    "\23\0\1\u0249\37\0\1\u024a\23\0\1\u024a\17\0\1\u024b"+
    "\23\0\1\u024b\47\0\1\u024c\23\0\1\u024c\25\0\1\u024d"+
    "\23\0\1\u024d\25\0\1\u024e\23\0\1\u024e\47\0\1\u024f"+
    "\23\0\1\u024f\30\0\1\u0250\23\0\1\u0250\30\0\1\u0251"+
    "\23\0\1\u0251\33\0\1\u0252\23\0\1\u0252\41\0\1\u0253"+
    "\23\0\1\u0253\34\0\1\u01ff\23\0\1\u01ff\12\0\1\u0254"+
    "\24\0\1\u0254\30\0\1\u0255\65\0\1\u0256\23\0\1\u0256"+
    "\25\0\1\u0257\47\0\2\u0255\2\0\4\u0255\1\u0258\23\u0255"+
    "\2\0\22\u0255\30\0\1\u0259\23\0\1\u0259\3\0\2\u0257"+
    "\2\0\4\u0257\1\u025a\23\u0257\2\0\22\u0257\7\0\1\u025b"+
    "\60\0\1\u025c\56\0\1\u025d\57\0\1\u025b\25\0\1\u025e"+
    "\22\0\2\u025c\2\0\4\u025c\1\u025f\23\u025c\2\0\22\u025c"+
    "\7\0\1\u025d\25\0\1\u0260\22\0\34\u0261\1\0\23\u0261"+
    "\7\0\1\u0262\50\0\34\u0263\1\0\23\u0263\34\u0261\1\u0264"+
    "\23\u0261\7\0\1\u0262\25\0\1\u0265\22\0\34\u0263\1\u0266"+
    "\23\u0263\6\0\1\u0267\51\0\34\u0268\1\0\23\u0268\6\0"+
    "\1\u0269\74\0\1\u026a\23\0\1\u026a\10\0\34\u0268\1\u026b"+
    "\23\u0268\23\0\1\u026c\23\0\1\u026c\32\0\1\u026d\23\0"+
    "\1\u026d\17\0\1\u026e\73\0\1\u026f\23\0\1\u026f\36\0"+
    "\1\u0270\23\0\1\u0270\31\0\1\u0271\23\0\1\u0271\35\0"+
    "\1\u0272\23\0\1\u0272\43\0\1\u0273\44\0\1\u0274\23\0"+
    "\1\u0274\46\0\1\u0275\23\0\2\u0276\1\0\1\u0277\1\u0276"+
    "\26\0\1\u0278\1\0\1\u0276\46\0\1\u0279\23\0\1\u0279"+
    "\7\0\2\u027a\1\0\1\u027b\1\u027c\26\0\1\u027d\1\0"+
    "\1\u027c\46\0\1\u027e\23\0\1\u027e\31\0\1\u027f\23\0"+
    "\1\u027f\45\0\1\u0280\47\0\1\u0281\23\0\1\u0281\7\0"+
    "\2\u027c\1\0\1\u0282\1\u027c\26\0\1\u0283\1\0\1\u027c"+
    "\44\0\1\u0284\23\0\1\u0284\23\0\1\u0285\24\0\1\u0285"+
    "\41\0\1\u0286\23\0\1\u0286\12\0\2\u0287\1\0\1\u0288"+
    "\1\u0287\26\0\1\u0289\1\0\1\u0287\34\0\1\u028a\24\0"+
    "\1\u028a\44\0\1\u028b\23\0\1\u028b\31\0\1\u028c\23\0"+
    "\1\u028c\32\0\1\u028d\23\0\1\u028d\42\0\1\u028e\23\0"+
    "\1\u028e\27\0\1\u028f\23\0\1\u028f\33\0\1\u0290\23\0"+
    "\1\u0290\31\0\1\u0291\23\0\1\u0291\41\0\1\u0292\23\0"+
    "\1\u0292\15\0\1\u0293\24\0\1\u0293\41\0\1\u0294\23\0"+
    "\1\u0294\36\0\1\u0295\23\0\1\u0295\35\0\1\u0296\23\0"+
    "\1\u0296\14\0\1\u0297\62\0\1\u0298\24\0\1\u0298\41\0"+
    "\1\u0299\23\0\1\u0299\40\0\1\u029a\23\0\1\u029a\35\0"+
    "\1\u029b\23\0\1\u029b\27\0\1\u029c\23\0\1\u029c\16\0"+
    "\1\u029d\60\0\1\u0276\67\0\1\u0246\7\0\1\u029e\13\0"+
    "\1\u0246\7\0\1\u029e\33\0\1\u029f\23\0\1\u029f\27\0"+
    "\1\u02a0\23\0\1\u02a0\17\0\1\u027a\75\0\1\u02a1\23\0"+
    "\1\u02a1\14\0\1\u02a2\63\0\1\u02a3\4\0\1\u02a4\1\0"+
    "\1\u02a5\5\0\1\u02a6\7\0\1\u02a3\3\0\1\u02a4\1\0"+
    "\1\u02a5\5\0\1\u02a6\34\0\1\u02a7\23\0\1\u02a7\30\0"+
    "\1\u02a8\23\0\1\u02a8\14\0\1\u02a9\60\0\1\u027c\62\0"+
    "\1\u02a3\4\0\1\u02a4\1\0\1\u02a5\5\0\1\u02aa\7\0"+
    "\1\u02a3\3\0\1\u02a4\1\0\1\u02a5\5\0\1\u02aa\30\0"+
    "\1\u02ab\23\0\1\u02ab\37\0\1\u02ac\23\0\1\u02ac\17\0"+
    "\1\u02ad\23\0\1\u02ad\47\0\1\u02ae\23\0\1\u02ae\30\0"+
    "\1\u02af\23\0\1\u02af\15\0\1\u0287\67\0\1\u02b0\1\0"+
    "\1\u0247\5\0\1\u02b1\13\0\1\u02b0\1\0\1\u0247\5\0"+
    "\1\u02b1\34\0\1\u02b2\23\0\1\u02b2\25\0\1\u02b3\23\0"+
    "\1\u02b3\25\0\1\u02b4\23\0\1\u02b4\47\0\1\u02b5\23\0"+
    "\1\u02b5\30\0\1\u02b6\23\0\1\u02b6\37\0\1\u02b7\23\0"+
    "\1\u02b7\32\0\1\u02b8\23\0\1\u02b8\33\0\1\u02b9\23\0"+
    "\1\u02b9\30\0\1\u02ba\23\0\1\u02ba\30\0\1\u02bb\23\0"+
    "\1\u02bb\33\0\1\u02bc\23\0\1\u02bc\41\0\1\u02bd\23\0"+
    "\1\u02bd\34\0\1\u02be\23\0\1\u02be\10\0\1\u02bf\65\0"+
    "\1\u02c0\23\0\1\u02c0\44\0\1\u02c1\23\0\1\u02c1\37\0"+
    "\1\u02c2\23\0\1\u02c2\12\0\1\u02c3\24\0\1\u02c3\30\0"+
    "\1\u02c4\65\0\1\u02c5\23\0\1\u02c5\25\0\1\u02c6\47\0"+
    "\2\u02bf\2\0\4\u02bf\1\u02c7\23\u02bf\2\0\22\u02bf\24\0"+
    "\1\u0259\23\0\1\u0259\42\0\1\u02c8\23\0\1\u02c8\10\0"+
    "\1\u02c9\57\0\1\u02ca\47\0\2\u02c4\2\0\4\u02c4\1\u02cb"+
    "\23\u02c4\2\0\22\u02c4\30\0\1\u02cc\23\0\1\u02cc\3\0"+
    "\2\u02c9\2\0\4\u02c9\1\u02cd\15\u02c9\1\u02ce\5\u02c9\2\0"+
    "\14\u02c9\1\u02ce\5\u02c9\7\0\1\u02cf\60\0\1\u02d0\47\0"+
    "\2\u02c9\2\0\4\u02c9\1\u02cd\23\u02c9\2\0\22\u02c9\2\u02ca"+
    "\2\0\4\u02ca\1\u02d1\23\u02ca\2\0\22\u02ca\7\0\1\u02d2"+
    "\60\0\1\u02d3\56\0\1\u02d4\50\0\2\u02c9\2\0\4\u02c9"+
    "\1\u02cd\6\u02c9\1\u02d5\14\u02c9\2\0\5\u02c9\1\u02d5\14\u02c9"+
    "\7\0\1\u02cf\25\0\1\u02d6\22\0\2\u02d0\2\0\4\u02d0"+
    "\1\u02d7\23\u02d0\2\0\22\u02d0\7\0\1\u02d8\57\0\1\u02d2"+
    "\25\0\1\u02d9\22\0\2\u02d3\2\0\4\u02d3\1\u02da\23\u02d3"+
    "\2\0\22\u02d3\7\0\1\u02d4\25\0\1\u02db\22\0\2\u02c9"+
    "\2\0\4\u02c9\1\u02dc\23\u02c9\2\0\22\u02c9\34\u02dd\1\0"+
    "\23\u02dd\7\0\1\u02de\57\0\1\u02d8\25\0\1\u02df\22\0"+
    "\34\u02e0\1\0\23\u02e0\7\0\1\u02e1\50\0\34\u02e2\1\0"+
    "\23\u02e2\7\0\1\u02e3\50\0\34\u02dd\1\u02e4\23\u02dd\7\0"+
    "\1\u02de\25\0\1\u02e5\22\0\34\u02e6\1\0\23\u02e6\34\u02e0"+
    "\1\u02e7\23\u02e0\7\0\1\u02e1\25\0\1\u02e8\22\0\34\u02e2"+
    "\1\u02e9\23\u02e2\7\0\1\u02e3\25\0\1\u02ea\30\0\1\u02eb"+
    "\51\0\34\u02ec\1\0\23\u02ec\34\u02e6\1\u02ed\23\u02e6\6\0"+
    "\1\u02ee\51\0\34\u02ef\1\0\23\u02ef\6\0\1\u02f0\51\0"+
    "\34\u02f1\1\0\23\u02f1\23\0\1\u02f2\23\0\1\u02f2\10\0"+
    "\34\u02ec\1\u02f3\23\u02ec\6\0\1\u02f4\74\0\1\u02f5\23\0"+
    "\1\u02f5\10\0\34\u02ef\1\u02f6\23\u02ef\23\0\1\u02f7\23\0"+
    "\1\u02f7\10\0\34\u02f1\1\u02f8\23\u02f1\22\0\1\u02f9\23\0"+
    "\1\u02f9\17\0\1\u02fa\74\0\1\u02fb\23\0\1\u02fb\32\0"+
    "\1\u02fc\23\0\1\u02fc\17\0\1\u02fd\73\0\1\u02fe\23\0"+
    "\1\u02fe\17\0\1\u02ff\76\0\1\u0300\23\0\1\u0300\31\0"+
    "\1\u0301\23\0\1\u0301\32\0\1\u0302\23\0\1\u0302\36\0"+
    "\1\u0303\23\0\1\u0303\31\0\1\u0304\23\0\1\u0304\35\0"+
    "\1\u0305\23\0\1\u0305\31\0\1\u0306\23\0\1\u0306\45\0"+
    "\1\u0276\44\0\1\u0307\23\0\1\u0307\36\0\1\u0308\23\0"+
    "\1\u0308\43\0\1\u0309\44\0\1\u030a\23\0\1\u030a\46\0"+
    "\1\u027c\44\0\1\u030b\23\0\1\u030b\36\0\1\u030c\23\0"+
    "\1\u030c\43\0\1\u030d\23\0\2\u030e\1\0\1\u030f\1\u0310"+
    "\26\0\1\u0311\1\0\1\u0310\46\0\1\u0312\23\0\1\u0312"+
    "\33\0\1\u0313\23\0\1\u0313\43\0\1\u0287\23\0\2\u0314"+
    "\1\0\1\u0315\1\u0316\26\0\1\u0317\1\0\1\u0316\46\0"+
    "\1\u0318\23\0\1\u0318\7\0\2\u0310\1\0\1\u0319\1\u0310"+
    "\26\0\1\u031a\1\0\1\u0310\44\0\1\u031b\23\0\1\u031b"+
    "\45\0\1\u031c\57\0\1\u031d\47\0\1\u031e\23\0\1\u031e"+
    "\7\0\2\u0316\1\0\1\u031f\1\u0316\26\0\1\u0320\1\0"+
    "\1\u0316\44\0\1\u0321\23\0\1\u0321\23\0\1\u0322\24\0"+
    "\1\u0322\44\0\1\u0323\23\0\1\u0323\31\0\1\u0324\23\0"+
    "\1\u0324\32\0\1\u0325\23\0\1\u0325\12\0\2\u0326\1\0"+
    "\1\u0327\1\u0328\26\0\1\u0329\1\0\1\u0328\22\0\2\u031d"+
    "\1\0\1\u032a\1\u027c\26\0\1\u032b\1\0\1\u027c\34\0"+
    "\1\u032c\24\0\1\u032c\44\0\1\u032d\23\0\1\u032d\31\0"+
    "\1\u032e\23\0\1\u032e\32\0\1\u032f\23\0\1\u032f\42\0"+
    "\1\u0330\23\0\1\u0330\15\0\1\u0331\24\0\1\u0331\41\0"+
    "\1\u0332\23\0\1\u0332\36\0\1\u0333\23\0\1\u0333\33\0"+
    "\1\u0334\23\0\1\u0334\7\0\2\u0328\1\0\1\u0335\1\u0328"+
    "\26\0\1\u0336\1\0\1\u0328\44\0\1\u0337\23\0\1\u0337"+
    "\35\0\1\u0338\23\0\1\u0338\31\0\1\u0339\23\0\1\u0339"+
    "\41\0\1\u033a\23\0\1\u033a\15\0\1\u033b\24\0\1\u033b"+
    "\41\0\1\u033c\23\0\1\u033c\36\0\1\u033d\23\0\1\u033d"+
    "\35\0\1\u033e\23\0\1\u033e\35\0\1\u033f\23\0\1\u033f"+
    "\27\0\1\u0340\23\0\1\u0340\16\0\1\u0341\62\0\1\u0342"+
    "\24\0\1\u0342\44\0\1\u0343\23\0\1\u0343\31\0\1\u0344"+
    "\23\0\1\u0344\32\0\1\u0345\23\0\1\u0345\24\0\1\u0346"+
    "\24\0\1\u0346\41\0\1\u0347\23\0\1\u0347\40\0\1\u0348"+
    "\23\0\1\u0348\35\0\1\u0349\23\0\1\u0349\27\0\1\u034a"+
    "\23\0\1\u034a\16\0\1\u034b\60\0\1\u030e\75\0\1\u034c"+
    "\23\0\1\u034c\14\0\1\u034d\70\0\1\u02a4\1\0\1\u034e"+
    "\5\0\1\u034f\13\0\1\u02a4\1\0\1\u034e\5\0\1\u034f"+
    "\33\0\1\u0350\23\0\1\u0350\15\0\1\u0351\24\0\1\u0351"+
    "\41\0\1\u0352\23\0\1\u0352\36\0\1\u0353\23\0\1\u0353"+
    "\37\0\1\u0354\23\0\1\u0354\27\0\1\u0355\23\0\1\u0355"+
    "\17\0\1\u0314\75\0\1\u0356\23\0\1\u0356\14\0\1\u0357"+
    "\63\0\1\u02a3\6\0\1\u02a5\5\0\1\u0358\7\0\1\u02a3"+
    "\5\0\1\u02a5\5\0\1\u0358\13\0\1\u0310\67\0\1\u02a4"+
    "\1\0\1\u034e\5\0\1\u0359\13\0\1\u02a4\1\0\1\u034e"+
    "\5\0\1\u0359\20\0\1\u035a\23\0\1\u035a\47\0\1\u035b"+
    "\23\0\1\u035b\30\0\1\u035c\23\0\1\u035c\35\0\1\u035d"+
    "\23\0\1\u035d\27\0\1\u035e\23\0\1\u035e\16\0\1\u035f"+
    "\76\0\1\u0360\23\0\1\u0360\14\0\1\u0361\60\0\1\u0316"+
    "\62\0\1\u02a3\6\0\1\u02a5\5\0\1\u0362\7\0\1\u02a3"+
    "\5\0\1\u02a5\5\0\1\u0362\34\0\1\u0363\23\0\1\u0363"+
    "\33\0\1\u0364\23\0\1\u0364\33\0\1\u0365\23\0\1\u0365"+
    "\30\0\1\u0366\23\0\1\u0366\15\0\1\u0326\75\0\1\u0367"+
    "\23\0\1\u0367\14\0\1\u0368\63\0\1\u02a3\4\0\1\u0369"+
    "\1\0\1\u02a5\5\0\1\u036a\7\0\1\u02a3\3\0\1\u0369"+
    "\1\0\1\u02a5\5\0\1\u036a\13\0\1\u031d\60\0\1\u036b"+
    "\1\0\1\u02a3\4\0\1\u02a4\1\0\1\u02a5\5\0\1\u02aa"+
    "\5\0\1\u036b\1\0\1\u02a3\3\0\1\u02a4\1\0\1\u02a5"+
    "\5\0\1\u02aa\34\0\1\u036c\23\0\1\u036c\30\0\1\u036d"+
    "\23\0\1\u036d\33\0\1\u036e\23\0\1\u036e\36\0\1\u036f"+
    "\23\0\1\u036f\34\0\1\u0370\23\0\1\u0370\11\0\1\u0328"+
    "\62\0\1\u02a3\4\0\1\u0369\1\0\1\u02a5\5\0\1\u0371"+
    "\7\0\1\u02a3\3\0\1\u0369\1\0\1\u02a5\5\0\1\u0371"+
    "\34\0\1\u0372\23\0\1\u0372\33\0\1\u0373\23\0\1\u0373"+
    "\31\0\1\u0374\23\0\1\u0374\32\0\1\u0375\23\0\1\u0375"+
    "\37\0\1\u0376\23\0\1\u0376\33\0\1\u0377\23\0\1\u0377"+
    "\16\0\1\u0378\23\0\1\u0378\25\0\1\u0379\101\0\1\u037a"+
    "\23\0\1\u037a\17\0\1\u037b\23\0\1\u037b\44\0\1\u037c"+
    "\23\0\1\u037c\36\0\1\u037d\23\0\1\u037d\34\0\1\u037e"+
    "\23\0\1\u037e\10\0\1\u037f\57\0\1\u0380\77\0\1\u02bc"+
    "\23\0\1\u02bc\3\0\2\u0380\2\0\4\u0380\1\u0381\15\u0380"+
    "\1\u0382\5\u0380\2\0\14\u0380\1\u0382\5\u0380\27\0\1\u0383"+
    "\23\0\1\u0383\30\0\1\u02cc\23\0\1\u02cc\42\0\1\u0384"+
    "\23\0\1\u0384\21\0\1\u0385\23\0\1\u0385\22\0\1\u0386"+
    "\47\0\2\u0386\2\0\4\u0386\1\u0387\15\u0386\1\u0388\5\u0386"+
    "\2\0\14\u0386\1\u0388\5\u0386\2\u0380\2\0\4\u0380\1\u0381"+
    "\23\u0380\2\0\22\u0380\7\0\1\u0389\50\0\2\u0380\2\0"+
    "\4\u0380\1\u0381\6\u0380\1\u038a\14\u0380\2\0\5\u0380\1\u038a"+
    "\14\u0380\33\0\1\u038b\23\0\1\u038b\10\0\1\u038c\63\0"+
    "\1\u038d\24\0\1\u038d\16\0\2\u0386\2\0\4\u0386\1\u0387"+
    "\23\u0386\2\0\22\u0386\7\0\1\u038e\50\0\2\u0386\2\0"+
    "\4\u0386\1\u0387\6\u0386\1\u038f\14\u0386\2\0\5\u0386\1\u038f"+
    "\14\u0386\7\0\1\u0389\25\0\1\u0390\22\0\2\u0380\2\0"+
    "\4\u0380\1\u0391\23\u0380\2\0\22\u0380\10\0\1\u0392\47\0"+
    "\2\u0392\2\0\4\u0392\1\u0393\15\u0392\1\u0394\5\u0392\2\0"+
    "\14\u0392\1\u0394\5\u0392\23\0\1\u0395\23\0\1\u0395\17\0"+
    "\1\u038e\25\0\1\u0396\22\0\2\u0386\2\0\4\u0386\1\u0397"+
    "\23\u0386\2\0\22\u0386\34\u0398\1\0\23\u0398\7\0\1\u0399"+
    "\50\0\2\u0392\2\0\4\u0392\1\u0393\23\u0392\2\0\22\u0392"+
    "\7\0\1\u039a\50\0\2\u0392\2\0\4\u0392\1\u0393\6\u0392"+
    "\1\u039b\14\u0392\2\0\5\u0392\1\u039b\14\u0392\16\0\1\u039c"+
    "\23\0\1\u039c\15\0\34\u039d\1\0\23\u039d\7\0\1\u039e"+
    "\50\0\34\u0398\1\u039f\23\u0398\7\0\1\u0399\25\0\1\u03a0"+
    "\31\0\1\u039a\25\0\1\u03a1\22\0\2\u0392\2\0\4\u0392"+
    "\1\u03a2\23\u0392\2\0\22\u0392\10\0\1\u03a3\47\0\34\u039d"+
    "\1\u03a4\23\u039d\7\0\1\u039e\25\0\1\u03a5\30\0\1\u03a6"+
    "\51\0\34\u03a7\1\0\23\u03a7\34\u03a8\1\0\23\u03a8\7\0"+
    "\1\u03a9\50\0\2\u03a3\2\0\4\u03a3\1\u03aa\23\u03a3\2\0"+
    "\22\u03a3\6\0\1\u03ab\51\0\34\u03ac\1\0\23\u03ac\23\0"+
    "\1\u03ad\23\0\1\u03ad\10\0\34\u03a7\1\u03ae\23\u03a7\34\u03a8"+
    "\1\u03af\23\u03a8\7\0\1\u03a9\25\0\1\u03b0\31\0\1\u03b1"+
    "\73\0\1\u03b2\23\0\1\u03b2\10\0\34\u03ac\1\u03b3\23\u03ac"+
    "\22\0\1\u03b4\23\0\1\u03b4\17\0\1\u03b5\57\0\1\u03b6"+
    "\51\0\34\u03b7\1\0\23\u03b7\7\0\1\u03b1\25\0\1\u03b8"+
    "\44\0\1\u03b9\23\0\1\u03b9\17\0\1\u03ba\76\0\1\u03bb"+
    "\23\0\1\u03bb\31\0\1\u03bc\23\0\1\u03bc\33\0\1\u03bd"+
    "\23\0\1\u03bd\10\0\34\u03b7\1\u03be\23\u03b7\34\u03bf\1\0"+
    "\23\u03bf\25\0\1\u03c0\23\0\1\u03c0\31\0\1\u03c1\23\0"+
    "\1\u03c1\45\0\1\u0310\44\0\1\u03c2\23\0\1\u03c2\33\0"+
    "\1\u03c3\23\0\1\u03c3\17\0\1\u03c4\51\0\34\u03bf\1\u03c5"+
    "\23\u03bf\35\0\1\u0316\44\0\1\u03c6\23\0\1\u03c6\36\0"+
    "\1\u03c7\23\0\1\u03c7\33\0\1\u03c8\23\0\1\u03c8\31\0"+
    "\1\u03c9\23\0\1\u03c9\16\0\1\u03ca\76\0\1\u03cb\23\0"+
    "\1\u03cb\43\0\1\u03cc\57\0\1\u0328\44\0\1\u03cd\23\0"+
    "\1\u03cd\34\0\1\u03ce\23\0\1\u03ce\45\0\1\u03cf\23\0"+
    "\2\u03cc\1\0\1\u03d0\1\u0310\26\0\1\u03d1\1\0\1\u0310"+
    "\46\0\1\u03d2\23\0\1\u03d2\30\0\1\u03d3\23\0\1\u03d3"+
    "\12\0\2\u03cf\1\0\1\u03d4\1\u0316\26\0\1\u03d5\1\0"+
    "\1\u0316\46\0\1\u03d6\23\0\1\u03d6\31\0\1\u03d7\23\0"+
    "\1\u03d7\45\0\1\u03d8\47\0\1\u03d9\23\0\1\u03d9\33\0"+
    "\1\u03da\23\0\1\u03da\31\0\1\u03db\23\0\1\u03db\23\0"+
    "\1\u03dc\24\0\1\u03dc\41\0\1\u03dd\23\0\1\u03dd\12\0"+
    "\2\u03d8\1\0\1\u03de\1\u0328\26\0\1\u03df\1\0\1\u0328"+
    "\56\0\1\u03e0\35\0\1\u03e1\24\0\1\u03e1\41\0\1\u03e2"+
    "\23\0\1\u03e2\42\0\1\u03e3\23\0\1\u03e3\27\0\1\u03e4"+
    "\23\0\1\u03e4\33\0\1\u03e5\23\0\1\u03e5\31\0\1\u03e6"+
    "\23\0\1\u03e6\41\0\1\u03e7\23\0\1\u03e7\27\0\1\u03e8"+
    "\23\0\1\u03e8\35\0\1\u03e9\23\0\1\u03e9\14\0\1\u03ea"+
    "\62\0\1\u03eb\24\0\1\u03eb\41\0\1\u03ec\23\0\1\u03ec"+
    "\40\0\1\u03ed\23\0\1\u03ed\14\0\1\u03ee\60\0\1\u03cc"+
    "\60\0\1\u036b\6\0\1\u02a4\1\0\1\u034e\5\0\1\u0359"+
    "\5\0\1\u036b\5\0\1\u02a4\1\0\1\u034e\5\0\1\u0359"+
    "\33\0\1\u03ef\23\0\1\u03ef\27\0\1\u03f0\23\0\1\u03f0"+
    "\17\0\1\u03cf\60\0\1\u036b\1\0\1\u02a3\6\0\1\u02a5"+
    "\5\0\1\u0362\5\0\1\u036b\1\0\1\u02a3\5\0\1\u02a5"+
    "\5\0\1\u0362\31\0\1\u03f1\23\0\1\u03f1\14\0\1\u03f2"+
    "\60\0\1\u03d8\60\0\1\u036b\1\0\1\u02a3\4\0\1\u0369"+
    "\1\0\1\u02a5\5\0\1\u0371\5\0\1\u036b\1\0\1\u02a3"+
    "\3\0\1\u0369\1\0\1\u02a5\5\0\1\u0371\2\0";

  private static int [] zzUnpacktrans() {
    int [] result = new int[47376];
    int offset = 0;
    offset = zzUnpacktrans(ZZ_TRANS_PACKED_0, offset, result);
    return result;
  }

  private static int zzUnpacktrans(String packed, int offset, int [] result) {
    int i = 0;       /* index in packed string  */
    int j = offset;  /* index in unpacked array */
    int l = packed.length();
    while (i < l) {
      int count = packed.charAt(i++);
      int value = packed.charAt(i++);
      value--;
      do result[j++] = value; while (--count > 0);
    }
    return j;
  }


  /** Error code for "Unknown internal scanner error". */
  private static final int ZZ_UNKNOWN_ERROR = 0;
  /** Error code for "could not match input". */
  private static final int ZZ_NO_MATCH = 1;
  /** Error code for "pushback value was too large". */
  private static final int ZZ_PUSHBACK_2BIG = 2;

  /**
   * Error messages for {@link #ZZ_UNKNOWN_ERROR}, {@link #ZZ_NO_MATCH}, and
   * {@link #ZZ_PUSHBACK_2BIG} respectively.
   */
  private static final String ZZ_ERROR_MSG[] = {
    "Unknown internal scanner error",
    "Error: could not match input",
    "Error: pushback value was too large"
  };

  /**
   * ZZ_ATTRIBUTE[aState] contains the attributes of state {@code aState}
   */
  private static final int [] ZZ_ATTRIBUTE = zzUnpackAttribute();

  private static final String ZZ_ATTRIBUTE_PACKED_0 =
    "\13\0\1\11\1\1\1\11\1\1\1\11\1\1\52\0"+
    "\1\11\135\0\1\11\150\0\1\1\17\0\1\11\43\0"+
    "\1\1\5\0\1\11\1\1\2\0\1\1\20\0\1\1"+
    "\4\0\1\1\40\0\1\11\251\0\1\11\13\0\1\11"+
    "\3\0\1\11\5\0\1\11\72\0\1\1\1\0\1\1"+
    "\12\0\1\1\210\0\1\1\3\0\1\1\16\0\1\1"+
    "\303\0\1\11\22\0";

  private static int [] zzUnpackAttribute() {
    int [] result = new int[1010];
    int offset = 0;
    offset = zzUnpackAttribute(ZZ_ATTRIBUTE_PACKED_0, offset, result);
    return result;
  }

  private static int zzUnpackAttribute(String packed, int offset, int [] result) {
    int i = 0;       /* index in packed string  */
    int j = offset;  /* index in unpacked array */
    int l = packed.length();
    while (i < l) {
      int count = packed.charAt(i++);
      int value = packed.charAt(i++);
      do result[j++] = value; while (--count > 0);
    }
    return j;
  }

  /** Input device. */
  private java.io.Reader zzReader;

  /** Current state of the DFA. */
  private int zzState;

  /** Current lexical state. */
  private int zzLexicalState = YYINITIAL;

  /**
   * This buffer contains the current text to be matched and is the source of the {@link #yytext()}
   * string.
   */
  private char zzBuffer[] = new char[Math.min(ZZ_BUFFERSIZE, zzMaxBufferLen())];

  /** Text position at the last accepting state. */
  private int zzMarkedPos;

  /** Current text position in the buffer. */
  private int zzCurrentPos;

  /** Marks the beginning of the {@link #yytext()} string in the buffer. */
  private int zzStartRead;

  /** Marks the last character in the buffer, that has been read from input. */
  private int zzEndRead;

  /**
   * Whether the scanner is at the end of file.
   * @see #yyatEOF
   */
  private boolean zzAtEOF;

  /**
   * The number of occupied positions in {@link #zzBuffer} beyond {@link #zzEndRead}.
   *
   * <p>When a lead/high surrogate has been read from the input stream into the final
   * {@link #zzBuffer} position, this will have a value of 1; otherwise, it will have a value of 0.
   */
  private int zzFinalHighSurrogate = 0;

  /** For the backwards DFA of general lookahead statements */
  private boolean [] zzFin = new boolean [Math.min(ZZ_BUFFERSIZE, zzMaxBufferLen())+1];

  /** Number of newlines encountered up to the start of the matched text. */
  private int yyline;

  /** Number of characters from the last newline up to the start of the matched text. */
  private int yycolumn;

  /** Number of characters up to the start of the matched text. */
  private long yychar;

  /** Whether the scanner is currently at the beginning of a line. */
  @SuppressWarnings("unused")
  private boolean zzAtBOL = true;

  /** Whether the user-EOF-code has already been executed. */
  @SuppressWarnings("unused")
  private boolean zzEOFDone;

  /* user code: */
	
	S182_AliasPartitions() { }
	
	private Reference reference = null;
	
	private Partition partitionEntity = null;
	
	private AnnotationEntity alias = null;
	
	private String context = "";
	
	private AnnotationEntity article = null;
	private AnnotationEntity comma = null;
	private AnnotationEntity letter = null;
	private AnnotationEntity item = null;
	
	private ArrayList<AnnotationEntity> referencesWithoutAlias = null;
	
	private void resetGlobal() {
	
		alias = null;
		
		context = "";
		
		article = null;
		comma = null;
		letter = null;
		item = null;		

		referencesWithoutAlias = new ArrayList<AnnotationEntity>();
	}
	
	private void readArticle() {
	
		AnnotationEntity retrievedEntity = retrieveEntity();
		position += retrievedEntity.getText().length();
		offset += yylength();
		
		article = retrievedEntity;

		reference = new Reference(Entity.LEG_REF_PART);
		partitionEntity = new Partition();
		reference.setContext(context);

		reference.addRelatedEntity(partitionEntity);
		partitionEntity.addRelatedEntity(retrievedEntity);
		
		reference.appendText(retrievedEntity.getText());
		referencesWithoutAlias.add(reference);
	}
	
	private void readComma() {
	
		AnnotationEntity retrievedEntity = retrieveEntity();
		position += retrievedEntity.getText().length();
		offset += yylength();
		
		comma = retrievedEntity;

		if(reference == null) {		
		
			reference = new Reference(Entity.LEG_REF_PART);
			partitionEntity = new Partition();
			reference.setContext(context);
			
			reference.addRelatedEntity(alias);

			reference.addRelatedEntity(partitionEntity);
			partitionEntity.addRelatedEntity(article);
		}

		partitionEntity.addRelatedEntity(comma);
		reference.appendText(comma.getText());
	}
	
	private void readLetter() {
	
		AnnotationEntity retrievedEntity = retrieveEntity();
		position += retrievedEntity.getText().length();
		offset += yylength();
		
		letter = retrievedEntity;

		if(reference == null) {		
		
			reference = new Reference(Entity.LEG_REF_PART);
			partitionEntity = new Partition();
			reference.setContext(context);
			
			reference.addRelatedEntity(alias);

			reference.addRelatedEntity(partitionEntity);
			partitionEntity.addRelatedEntity(article);
			if(comma != null) partitionEntity.addRelatedEntity(comma);
		}

		partitionEntity.addRelatedEntity(letter);
		reference.appendText(letter.getText());
	}
	
	private void readItem() {
	
		AnnotationEntity retrievedEntity = retrieveEntity();
		position += retrievedEntity.getText().length();
		offset += yylength();
		
		item = retrievedEntity;

		if(reference == null) {		
		
			reference = new Reference(Entity.LEG_REF_PART);
			partitionEntity = new Partition();
			reference.setContext(context);
			
			reference.addRelatedEntity(alias);

			reference.addRelatedEntity(partitionEntity);
			partitionEntity.addRelatedEntity(article);
			if(comma != null) partitionEntity.addRelatedEntity(comma);
			if(letter != null) partitionEntity.addRelatedEntity(letter);
		}

		partitionEntity.addRelatedEntity(item);
		reference.appendText(item.getText());
	}



  /**
   * Creates a new scanner
   *
   * @param   in  the java.io.Reader to read input from.
   */
  S182_AliasPartitions(java.io.Reader in) {
    this.zzReader = in;
  }


  /** Returns the maximum size of the scanner buffer, which limits the size of tokens. */
  private int zzMaxBufferLen() {
    return Integer.MAX_VALUE;
  }

  /**  Whether the scanner buffer can grow to accommodate a larger token. */
  private boolean zzCanGrow() {
    return true;
  }

  /**
   * Translates raw input code points to DFA table row
   */
  private static int zzCMap(int input) {
    int offset = input & 255;
    return offset == input ? ZZ_CMAP_BLOCKS[offset] : ZZ_CMAP_BLOCKS[ZZ_CMAP_TOP[input >> 8] | offset];
  }

  /**
   * Refills the input buffer.
   *
   * @return {@code false} iff there was new input.
   * @exception java.io.IOException  if any I/O-Error occurs
   */
  private boolean zzRefill() throws java.io.IOException {

    /* first: make room (if you can) */
    if (zzStartRead > 0) {
      zzEndRead += zzFinalHighSurrogate;
      zzFinalHighSurrogate = 0;
      System.arraycopy(zzBuffer, zzStartRead,
                       zzBuffer, 0,
                       zzEndRead - zzStartRead);

      /* translate stored positions */
      zzEndRead -= zzStartRead;
      zzCurrentPos -= zzStartRead;
      zzMarkedPos -= zzStartRead;
      zzStartRead = 0;
    }

    /* is the buffer big enough? */
    if (zzCurrentPos >= zzBuffer.length - zzFinalHighSurrogate && zzCanGrow()) {
      /* if not, and it can grow: blow it up */
      char newBuffer[] = new char[Math.min(zzBuffer.length * 2, zzMaxBufferLen())];
      System.arraycopy(zzBuffer, 0, newBuffer, 0, zzBuffer.length);
      zzBuffer = newBuffer;
      zzEndRead += zzFinalHighSurrogate;
      zzFinalHighSurrogate = 0;
    }

    /* fill the buffer with new input */
    int requested = zzBuffer.length - zzEndRead;
    int numRead = zzReader.read(zzBuffer, zzEndRead, requested);

    /* not supposed to occur according to specification of java.io.Reader */
    if (numRead == 0) {
      if (requested == 0) {
        throw new java.io.EOFException("Scan buffer limit reached ["+zzBuffer.length+"]");
      }
      else {
        throw new java.io.IOException(
            "Reader returned 0 characters. See JFlex examples/zero-reader for a workaround.");
      }
    }
    if (numRead > 0) {
      zzEndRead += numRead;
      if (Character.isHighSurrogate(zzBuffer[zzEndRead - 1])) {
        if (numRead == requested) { // We requested too few chars to encode a full Unicode character
          --zzEndRead;
          zzFinalHighSurrogate = 1;
        } else {                    // There is room in the buffer for at least one more char
          int c = zzReader.read();  // Expecting to read a paired low surrogate char
          if (c == -1) {
            return true;
          } else {
            zzBuffer[zzEndRead++] = (char)c;
          }
        }
      }
      /* potentially more input available */
      return false;
    }

    /* numRead < 0 ==> end of stream */
    return true;
  }


  /**
   * Closes the input reader.
   *
   * @throws java.io.IOException if the reader could not be closed.
   */
  public final void yyclose() throws java.io.IOException {
    zzAtEOF = true; // indicate end of file
    zzEndRead = zzStartRead; // invalidate buffer

    if (zzReader != null) {
      zzReader.close();
    }
  }


  /**
   * Resets the scanner to read from a new input stream.
   *
   * <p>Does not close the old reader.
   *
   * <p>All internal variables are reset, the old input stream <b>cannot</b> be reused (internal
   * buffer is discarded and lost). Lexical state is set to {@code ZZ_INITIAL}.
   *
   * <p>Internal scan buffer is resized down to its initial length, if it has grown.
   *
   * @param reader The new input stream.
   */
  public final void yyreset(java.io.Reader reader) {
    zzReader = reader;
    zzEOFDone = false;
    yyResetPosition();
    zzLexicalState = YYINITIAL;
    int initBufferSize = Math.min(ZZ_BUFFERSIZE, zzMaxBufferLen());
    if (zzBuffer.length > initBufferSize) {
      zzBuffer = new char[initBufferSize];
    }
  }

  /**
   * Resets the input position.
   */
  private final void yyResetPosition() {
      zzAtBOL  = true;
      zzAtEOF  = false;
      zzCurrentPos = 0;
      zzMarkedPos = 0;
      zzStartRead = 0;
      zzEndRead = 0;
      zzFinalHighSurrogate = 0;
      yyline = 0;
      yycolumn = 0;
      yychar = 0L;
  }


  /**
   * Returns whether the scanner has reached the end of the reader it reads from.
   *
   * @return whether the scanner has reached EOF.
   */
  public final boolean yyatEOF() {
    return zzAtEOF;
  }


  /**
   * Returns the current lexical state.
   *
   * @return the current lexical state.
   */
  public final int yystate() {
    return zzLexicalState;
  }


  /**
   * Enters a new lexical state.
   *
   * @param newState the new lexical state
   */
  public final void yybegin(int newState) {
    zzLexicalState = newState;
  }


  /**
   * Returns the text matched by the current regular expression.
   *
   * @return the matched text.
   */
  public final String yytext() {
    return new String(zzBuffer, zzStartRead, zzMarkedPos-zzStartRead);
  }


  /**
   * Returns the character at the given position from the matched text.
   *
   * <p>It is equivalent to {@code yytext().charAt(pos)}, but faster.
   *
   * @param position the position of the character to fetch. A value from 0 to {@code yylength()-1}.
   *
   * @return the character at {@code position}.
   */
  public final char yycharat(int position) {
    return zzBuffer[zzStartRead + position];
  }


  /**
   * How many characters were matched.
   *
   * @return the length of the matched text region.
   */
  public final int yylength() {
    return zzMarkedPos-zzStartRead;
  }


  /**
   * Reports an error that occurred while scanning.
   *
   * <p>In a well-formed scanner (no or only correct usage of {@code yypushback(int)} and a
   * match-all fallback rule) this method will only be called with things that
   * "Can't Possibly Happen".
   *
   * <p>If this method is called, something is seriously wrong (e.g. a JFlex bug producing a faulty
   * scanner etc.).
   *
   * <p>Usual syntax/scanner level error handling should be done in error fallback rules.
   *
   * @param errorCode the code of the error message to display.
   */
  private static void zzScanError(int errorCode) {
    String message;
    try {
      message = ZZ_ERROR_MSG[errorCode];
    } catch (ArrayIndexOutOfBoundsException e) {
      message = ZZ_ERROR_MSG[ZZ_UNKNOWN_ERROR];
    }

    throw new Error(message);
  }


  /**
   * Pushes the specified amount of characters back into the input stream.
   *
   * <p>They will be read again by then next call of the scanning method.
   *
   * @param number the number of characters to be read again. This number must not be greater than
   *     {@link #yylength()}.
   */
  public void yypushback(int number)  {
    if ( number > yylength() )
      zzScanError(ZZ_PUSHBACK_2BIG);

    zzMarkedPos -= number;
  }




  /**
   * Resumes scanning until the next regular expression is matched, the end of input is encountered
   * or an I/O-Error occurs.
   *
   * @return the next token.
   * @exception java.io.IOException if any I/O-Error occurs.
   */
  public int yylex() throws java.io.IOException
  {
    int zzInput;
    int zzAction;

    // cached fields:
    int zzCurrentPosL;
    int zzMarkedPosL;
    int zzEndReadL = zzEndRead;
    char[] zzBufferL = zzBuffer;

    int [] zzTransL = ZZ_TRANS;
    int [] zzRowMapL = ZZ_ROWMAP;
    int [] zzAttrL = ZZ_ATTRIBUTE;

    while (true) {
      zzMarkedPosL = zzMarkedPos;

      yychar+= zzMarkedPosL-zzStartRead;

      boolean zzR = false;
      int zzCh;
      int zzCharCount;
      for (zzCurrentPosL = zzStartRead  ;
           zzCurrentPosL < zzMarkedPosL ;
           zzCurrentPosL += zzCharCount ) {
        zzCh = Character.codePointAt(zzBufferL, zzCurrentPosL, zzMarkedPosL);
        zzCharCount = Character.charCount(zzCh);
        switch (zzCh) {
        case '\u000B':  // fall through
        case '\u000C':  // fall through
        case '\u0085':  // fall through
        case '\u2028':  // fall through
        case '\u2029':
          yyline++;
          yycolumn = 0;
          zzR = false;
          break;
        case '\r':
          yyline++;
          yycolumn = 0;
          zzR = true;
          break;
        case '\n':
          if (zzR)
            zzR = false;
          else {
            yyline++;
            yycolumn = 0;
          }
          break;
        default:
          zzR = false;
          yycolumn += zzCharCount;
        }
      }

      if (zzR) {
        // peek one character ahead if it is
        // (if we have counted one line too much)
        boolean zzPeek;
        if (zzMarkedPosL < zzEndReadL)
          zzPeek = zzBufferL[zzMarkedPosL] == '\n';
        else if (zzAtEOF)
          zzPeek = false;
        else {
          boolean eof = zzRefill();
          zzEndReadL = zzEndRead;
          zzMarkedPosL = zzMarkedPos;
          zzBufferL = zzBuffer;
          if (eof)
            zzPeek = false;
          else
            zzPeek = zzBufferL[zzMarkedPosL] == '\n';
        }
        if (zzPeek) yyline--;
      }
      zzAction = -1;

      zzCurrentPosL = zzCurrentPos = zzStartRead = zzMarkedPosL;

      zzState = ZZ_LEXSTATE[zzLexicalState];

      // set up zzAction for empty match case:
      int zzAttributes = zzAttrL[zzState];
      if ( (zzAttributes & 1) == 1 ) {
        zzAction = zzState;
      }


      zzForAction: {
        while (true) {

          if (zzCurrentPosL < zzEndReadL) {
            zzInput = Character.codePointAt(zzBufferL, zzCurrentPosL, zzEndReadL);
            zzCurrentPosL += Character.charCount(zzInput);
          }
          else if (zzAtEOF) {
            zzInput = YYEOF;
            break zzForAction;
          }
          else {
            // store back cached positions
            zzCurrentPos  = zzCurrentPosL;
            zzMarkedPos   = zzMarkedPosL;
            boolean eof = zzRefill();
            // get translated positions and possibly new buffer
            zzCurrentPosL  = zzCurrentPos;
            zzMarkedPosL   = zzMarkedPos;
            zzBufferL      = zzBuffer;
            zzEndReadL     = zzEndRead;
            if (eof) {
              zzInput = YYEOF;
              break zzForAction;
            }
            else {
              zzInput = Character.codePointAt(zzBufferL, zzCurrentPosL, zzEndReadL);
              zzCurrentPosL += Character.charCount(zzInput);
            }
          }
          int zzNext = zzTransL[ zzRowMapL[zzState] + zzCMap(zzInput) ];
          if (zzNext == -1) break zzForAction;
          zzState = zzNext;

          zzAttributes = zzAttrL[zzState];
          if ( (zzAttributes & 1) == 1 ) {
            zzAction = zzState;
            zzMarkedPosL = zzCurrentPosL;
            if ( (zzAttributes & 8) == 8 ) break zzForAction;
          }

        }
      }

      // store back cached position
      zzMarkedPos = zzMarkedPosL;

      if (zzInput == YYEOF && zzStartRead == zzCurrentPos) {
        zzAtEOF = true;
        return YYEOF;
      }
      else {
        switch (zzAction < 0 ? zzAction : ZZ_ACTION[zzAction]) {
          case 1:
            { addText();
	position++;
            }
          // fall through
          case 18: break;
          case 2:
            { addText();
		position++;
            }
          // fall through
          case 19: break;
          case 3:
            { offset++;
		position++;
		
		if(offset >= length) {
			
			if(offset > length) {
				yypushback(1);
				position--;
			}
			
			if(reference != null) addEntity(reference);
			
			yybegin(0);
		
		} else {
		
			if(reference == null) { 
				
				addText();
			
			} else {
			
				reference.appendText(yytext());
			}
		}
            }
          // fall through
          case 20: break;
          case 4:
            { addText();
		position--; //account for the following {LKN_C} character
		yybegin(YYINITIAL);
            }
          // fall through
          case 21: break;
          case 5:
            { addText(); 
	yybegin(lkn);
            }
          // fall through
          case 22: break;
          case 6:
            { if(offset == length) {
			
			yypushback(yylength());
			
			if(reference != null) addEntity(reference);
			
			yybegin(0);
		
		} else {

			AnnotationEntity retrievedEntity = retrieveEntity();
			
			if(reference == null) { 
				
				addText();
			
			} else {
			
				reference.appendText(retrievedEntity.getText());
			}
			
			position += retrievedEntity.getText().length(); 
			offset += yylength();
		}
            }
          // fall through
          case 23: break;
          case 7:
            { readItem();
            }
          // fall through
          case 24: break;
          case 8:
            { readComma();
            }
          // fall through
          case 25: break;
          case 9:
            { readLetter();
            }
          // fall through
          case 26: break;
          case 10:
            { readArticle();
            }
          // fall through
          case 27: break;
          case 11:
            { //salva l'alias e aggiungilo a tutti i riferimenti precedenti già creati (relativi agli articoli che precedono l'alias)
		
		AnnotationEntity retrievedEntity = retrieveEntity();
		position += retrievedEntity.getText().length();
		offset += yylength();
		
		alias = retrievedEntity;
		
		reference.appendText(alias.getText());
		
		for(AnnotationEntity reference : referencesWithoutAlias) {
			
			reference.addRelatedEntity(alias);	
		}
            }
          // fall through
          case 28: break;
          case 12:
            // general lookahead, find correct zzMarkedPos
            { int zzFState = 9;
              int zzFPos = zzStartRead;
              if (zzFin.length <= zzBufferL.length) {
                zzFin = new boolean[zzBufferL.length+1];
              }
              boolean zzFinL[] = zzFin;
              while (zzFState != -1 && zzFPos < zzMarkedPos) {
                zzFinL[zzFPos] = ((zzAttrL[zzFState] & 1) == 1);
                zzInput = Character.codePointAt(zzBufferL, zzFPos, zzMarkedPos);
                zzFPos += Character.charCount(zzInput);
                zzFState = zzTransL[ zzRowMapL[zzFState] + zzCMap(zzInput) ];
              }
              if (zzFState != -1) {
                zzFinL[zzFPos++] = ((zzAttrL[zzFState] & 1) == 1);
              }
              while (zzFPos <= zzMarkedPos) {
                zzFinL[zzFPos++] = false;
              }

              zzFState = 10;
              zzFPos = zzMarkedPos;
              while (!zzFinL[zzFPos] || (zzAttrL[zzFState] & 1) != 1) {
                zzInput = Character.codePointBefore(zzBufferL, zzFPos, zzStartRead);
                zzFPos -= Character.charCount(zzInput);
                zzFState = zzTransL[ zzRowMapL[zzFState] + zzCMap(zzInput) ];
              };
              zzMarkedPos = zzFPos;
            }
            { readItem();		
		
		addEntity(reference);
		reference = null;
            }
          // fall through
          case 29: break;
          case 13:
            // general lookahead, find correct zzMarkedPos
            { int zzFState = 5;
              int zzFPos = zzStartRead;
              if (zzFin.length <= zzBufferL.length) {
                zzFin = new boolean[zzBufferL.length+1];
              }
              boolean zzFinL[] = zzFin;
              while (zzFState != -1 && zzFPos < zzMarkedPos) {
                zzFinL[zzFPos] = ((zzAttrL[zzFState] & 1) == 1);
                zzInput = Character.codePointAt(zzBufferL, zzFPos, zzMarkedPos);
                zzFPos += Character.charCount(zzInput);
                zzFState = zzTransL[ zzRowMapL[zzFState] + zzCMap(zzInput) ];
              }
              if (zzFState != -1) {
                zzFinL[zzFPos++] = ((zzAttrL[zzFState] & 1) == 1);
              }
              while (zzFPos <= zzMarkedPos) {
                zzFinL[zzFPos++] = false;
              }

              zzFState = 6;
              zzFPos = zzMarkedPos;
              while (!zzFinL[zzFPos] || (zzAttrL[zzFState] & 1) != 1) {
                zzInput = Character.codePointBefore(zzBufferL, zzFPos, zzStartRead);
                zzFPos -= Character.charCount(zzInput);
                zzFState = zzTransL[ zzRowMapL[zzFState] + zzCMap(zzInput) ];
              };
              zzMarkedPos = zzFPos;
            }
            { readComma();		
		
		addEntity(reference);
		reference = null;
            }
          // fall through
          case 30: break;
          case 14:
            // general lookahead, find correct zzMarkedPos
            { int zzFState = 7;
              int zzFPos = zzStartRead;
              if (zzFin.length <= zzBufferL.length) {
                zzFin = new boolean[zzBufferL.length+1];
              }
              boolean zzFinL[] = zzFin;
              while (zzFState != -1 && zzFPos < zzMarkedPos) {
                zzFinL[zzFPos] = ((zzAttrL[zzFState] & 1) == 1);
                zzInput = Character.codePointAt(zzBufferL, zzFPos, zzMarkedPos);
                zzFPos += Character.charCount(zzInput);
                zzFState = zzTransL[ zzRowMapL[zzFState] + zzCMap(zzInput) ];
              }
              if (zzFState != -1) {
                zzFinL[zzFPos++] = ((zzAttrL[zzFState] & 1) == 1);
              }
              while (zzFPos <= zzMarkedPos) {
                zzFinL[zzFPos++] = false;
              }

              zzFState = 8;
              zzFPos = zzMarkedPos;
              while (!zzFinL[zzFPos] || (zzAttrL[zzFState] & 1) != 1) {
                zzInput = Character.codePointBefore(zzBufferL, zzFPos, zzStartRead);
                zzFPos -= Character.charCount(zzInput);
                zzFState = zzTransL[ zzRowMapL[zzFState] + zzCMap(zzInput) ];
              };
              zzMarkedPos = zzFPos;
            }
            { readLetter();		
		
		addEntity(reference);
		reference = null;
            }
          // fall through
          case 31: break;
          case 15:
            // general lookahead, find correct zzMarkedPos
            { int zzFState = 3;
              int zzFPos = zzStartRead;
              if (zzFin.length <= zzBufferL.length) {
                zzFin = new boolean[zzBufferL.length+1];
              }
              boolean zzFinL[] = zzFin;
              while (zzFState != -1 && zzFPos < zzMarkedPos) {
                zzFinL[zzFPos] = ((zzAttrL[zzFState] & 1) == 1);
                zzInput = Character.codePointAt(zzBufferL, zzFPos, zzMarkedPos);
                zzFPos += Character.charCount(zzInput);
                zzFState = zzTransL[ zzRowMapL[zzFState] + zzCMap(zzInput) ];
              }
              if (zzFState != -1) {
                zzFinL[zzFPos++] = ((zzAttrL[zzFState] & 1) == 1);
              }
              while (zzFPos <= zzMarkedPos) {
                zzFinL[zzFPos++] = false;
              }

              zzFState = 4;
              zzFPos = zzMarkedPos;
              while (!zzFinL[zzFPos] || (zzAttrL[zzFState] & 1) != 1) {
                zzInput = Character.codePointBefore(zzBufferL, zzFPos, zzStartRead);
                zzFPos -= Character.charCount(zzInput);
                zzFState = zzTransL[ zzRowMapL[zzFState] + zzCMap(zzInput) ];
              };
              zzMarkedPos = zzFPos;
            }
            { readArticle();
		
		addEntity(reference);
		reference = null;
            }
          // fall through
          case 32: break;
          case 16:
            { //crea un riferimento normativo
	
	//System.out.println("PATTERN " + yytext());
	
	resetGlobal();
	
	context = yytext();

	start(null, globalState, false, false);
            }
          // fall through
          case 33: break;
          case 17:
            { addText();
	
	position += Util.removeAllAnnotations(yytext()).length();
            }
          // fall through
          case 34: break;
          default:
            zzScanError(ZZ_NO_MATCH);
        }
      }
    }
  }

  /**
   * Runs the scanner on input files.
   *
   * This is a standalone scanner, it will print any unmatched
   * text to System.out unchanged.
   *
   * @param argv   the command line, contains the filenames to run
   *               the scanner on.
   */
  public static void main(String[] argv) {
    if (argv.length == 0) {
      System.out.println("Usage : java S182_AliasPartitions [ --encoding <name> ] <inputfile(s)>");
    }
    else {
      int firstFilePos = 0;
      String encodingName = "UTF-8";
      if (argv[0].equals("--encoding")) {
        firstFilePos = 2;
        encodingName = argv[1];
        try {
          // Side-effect: is encodingName valid?
          java.nio.charset.Charset.forName(encodingName);
        } catch (Exception e) {
          System.out.println("Invalid encoding '" + encodingName + "'");
          return;
        }
      }
      for (int i = firstFilePos; i < argv.length; i++) {
        S182_AliasPartitions scanner = null;
        java.io.FileInputStream stream = null;
        java.io.Reader reader = null;
        try {
          stream = new java.io.FileInputStream(argv[i]);
          reader = new java.io.InputStreamReader(stream, encodingName);
          scanner = new S182_AliasPartitions(reader);
          while ( !scanner.zzAtEOF ) scanner.yylex();
        }
        catch (java.io.FileNotFoundException e) {
          System.out.println("File not found : \""+argv[i]+"\"");
        }
        catch (java.io.IOException e) {
          System.out.println("IO error scanning file \""+argv[i]+"\"");
          System.out.println(e);
        }
        catch (Exception e) {
          System.out.println("Unexpected exception:");
          e.printStackTrace();
        }
        finally {
          if (reader != null) {
            try {
              reader.close();
            }
            catch (java.io.IOException e) {
              System.out.println("IO error closing file \""+argv[i]+"\"");
              System.out.println(e);
            }
          }
          if (stream != null) {
            try {
              stream.close();
            }
            catch (java.io.IOException e) {
              System.out.println("IO error closing file \""+argv[i]+"\"");
              System.out.println(e);
            }
          }
        }
      }
    }
  }


}
